Package: CSAMA10
Type: Package
Title: Computational Statistics for Genome Biology 2010
Version: 0.0.3
Author: Martin Morgan <mtmorgan@fhcrc.org>, Patrick Aboyoun
    <paboyoun@fhcrc.org>, Simon Anders, Robert Gentleman, Florian Hahne,
    Wolfgang Huber, Audrey Kauffman, Gregoire Pau
Maintainer: Martin Morgan <mtmorgan@fhcrc.org>
License: Artistic-2.0
LazyLoad: yes
Description: This package contains material for 'CSAMA10', which took place
    in Bressanone-Brixen, Italy from June 13th-18th 2010.
Depends: IRanges, GenomicRanges, Biostrings, BSgenome, Rsamtools,
    ShortRead, rtracklayer, biomaRt, GenomicFeatures, EatonEtAlChIPseq,
    chipseq
Imports: IRanges, GenomicRanges, Biostrings, ShortRead, GenomicFeatures
Suggests: BSgenome.Scerevisiae.UCSC.sacCer2, org.Sc.sgd.db, KEGG.db,
    BSgenome.Hsapiens.UCSC.hg19, SNPlocs.Hsapiens.dbSNP.20090506, DESeq,
    hgu95av2probe, bitops
Packaged: 2010-07-02 23:02:31 UTC; patrick

library(GenomicFeatures)
fl <- system.file("extdata",
                  "CaffeineTxdb.sqlite", 
                  package="Rsamtools")
bamRanges <- transcripts(loadFeatures(fl))

library(Rsamtools)
fl <- system.file("extdata",
                  "slxMaq09_urls.txt", 
                  package="Rsamtools")
slxMaq09 <- readLines(fl)

bamExperiment <- 
    list(description="Caffeine metabolism views on 1000 genomes samples",
         created=date())
bv <- BamViews(slxMaq09, bamRanges=bamRanges, 
               bamExperiment=bamExperiment)

bv
bamExperiment(bv)

## olaps <- readBamGappedAlignments(bv)
load(system.file("extdata", "olaps.Rda",
                 package="Rsamtools"))

olaps
head(olaps[[1]])

library(EatonEtAlChIPseq)
fl <- system.file("extdata", 
  "GSM424494_wt_G2_orc_chip_rep1_S288C_14.mapview.txt.gz",
  package="EatonEtAlChIPseq") 
aln <- readAligned(fl, type = "MAQMapview")
alnp <- aln[strand(aln) == "+"]            

islands0 <- slice(coverage(alnp), 1)
(islands <- islands0[["S288C_14"]])
idx <- head(order(viewMaxs(islands),
                  decreasing=TRUE))
bigIslands <- islands[idx]
rle <- bigIslands[[1]]
plot(start(bigIslands)[[1]] + cumsum(runLength(rle)), 
     runValue(rle), type="l")

library(org.Sc.sgd.db)
start <- toTable(org.Sc.sgdCHRLOC)
end <- toTable(org.Sc.sgdCHRLOCEND)
tbl <- merge(start, end)
tbl <- with(tbl,
            tbl[Chromosome=='14' & start > 0,])
head(tbl)

library(Biobase)
pts <- matchpt(end(bigIslands), tbl$start)
tbl[pts$index,]
ids <- tbl[pts$index, "systematic_name"]
toTable(org.Sc.sgdDESCRIPTION[ids])

owd <- setwd("/home/mtmorgan/proj/a/1000g/")
library(Rsamtools)
library(ShortRead)

makeStreamBatches <-
    function(file, seqname, length.out, ...)
{
    len <-
        scanBamHeader(file)[[1]][["targets"]][[seqname]] + 1
    cuts <-
        seq.int(1, len, length.out=length.out)
    start <- cuts[-length(cuts)]
    end <- cuts[-1] - 1
    which <- GRanges(seqname,
                     IRanges(start, end),
                     strand="*")
    ScanBamParam(which=which, ...)
}

streamBam <-
    function(file, index = file, ...,
             MAP, REDUCE=append,
             param=ScanBamParam())
{
    ## FIXME reads overlapping batches are visited twice
    len <- length(bamWhich(param)[[1]])
    idx <- seq_len(len)
    param0 <- param
    progress <- txtProgressBar(1, len)
    mapped <- Map(function(idx) {
        setTxtProgressBar(progress, idx)
        bamWhich(param)[[1]] <-
            bamWhich(param0)[[1]][idx]
        block <- scanBam(file, index, ...,
                         param=param)[[1]]
        MAP(block)
    }, idx)
    Reduce(REDUCE, mapped)
}

file <- "NA19240.chrom6.SLX.maq.SRP000032.2009_07.bam"

param <- makeStreamBatches(file, "6", 1000,
                         what=c("seq", "qual"))
bamWhich(param)[[1]] <-
    bamWhich(param)[[1]][1:10]

gcEnriched <-
    function(x)
{
    sr <- ShortReadQ(x[["seq"]],
                     FastqQuality(as(x[["qual"]], "BStringSet")))
    alph <- alphabetFrequency(sread(sr))
    gc <-  rowSums(alph[,c("G", "C")]) /
               rowSums(alph)
    sr[ gc > .8 ]
}

srq <- streamBam(file, param=param,
                 MAP=gcEnriched)
srq

table(width(srq))

srq36 <- srq[ width(srq) == 36 ]
abc <- alphabetByCycle(sread(srq36),
                       collapse=TRUE)
matplot(t(abc[1:4,]))

setwd(owd)

geneBounds <- function(txdb)
{
    if (!is(txdb, "TranscriptDb")) 
        stop("'txdb' must be a TranscriptDb object")
    genes <- transcriptsBy(txdb, "gene")
    elementMetadata(genes@unlistData) <- NULL
    empty <- which(elementLengths(genes) == 0L)
    if (length(empty) > 0)
        genes <- genes[- empty]
    ranges <- unlist(reduce(ranges(genes)))
    genes <-
      unlist(seqselect(genes, rep(IntegerList(1L), length(genes))),
             use.names=FALSE)
    genes@ranges <- ranges
    genes
}

geneIntrons <- function(txdb)
{
    if (!is(txdb, "TranscriptDb")) 
        stop("'txdb' must be a TranscriptDb object")
    genes <- exonsBy(txdb, "gene")
    elementMetadata(genes@unlistData) <- NULL
    empty <- which(elementLengths(genes) == 0L)
    if (length(empty) > 0)
        genes <- genes[- empty]
    ranges <- gaps(ranges(genes))
    first <- unlist(genes[rep(IntegerList(1L), length(genes))])
    seqnames <- Rle(as.vector(seqnames(first)), elementLengths(ranges))
    strand <- Rle(as.vector(strand(first)), elementLengths(ranges))
    granges <-
      GRanges(seqnames = seqnames, ranges = unlist(ranges, use.names=FALSE),
              strand = strand)
    new("GRangesList", unlistData = granges,
        partitioning = ranges@partitioning,
        elementMetadata = new("DataFrame", nrows = length(ranges)))
}

countExonIdsByTxOverlaps <- function(txdb, subject)
{
    if (!is(txdb, "TranscriptDb")) 
        stop("'txdb' must be a TranscriptDb object")
    exons <- exons(txdb)
    exonCounts <- countOverlaps(exons, subject)
    names(exonCounts) <- as.character(values(exons)[["exon_id"]])
    exonsByTx <- exonsBy(txdb, "tx")

    exonIdsByTxCounts <-
      new("CompressedIntegerList",
          unlistData =
          unname(exonCounts[as.character(values(exonsByTx@unlistData)[["exon_id"]])]),
          partitioning = exonsByTx@partitioning)
    exonIdsByTxCounts <-
      exonIdsByTxCounts[order(sum(exonIdsByTxCounts), decreasing=TRUE)]
    
    tx <- transcripts(txdb, columns = c("tx_id", "gene_id"))
    geneMapping <- unlist(values(tx)[["gene_id"]])[names(exonIdsByTxCounts)]
    geneMapping <- factor(geneMapping, levels = unique(geneMapping))
    split(DataFrame(tx_id = as.integer(names(exonIdsByTxCounts)),
                    exon_counts = exonIdsByTxCounts,
                    total_count = sum(exonIdsByTxCounts)),
          geneMapping)
}


rpkm <- function(count, ranges)
{
    if (missing(ranges))
        stop("'ranges' must be a GRanges or GRangesList object")
    else if (is(ranges, "GRanges"))
        numBases <- width(ranges)
    else if (is(ranges, "GRangesList"))
        numBases <- sum(width(ranges))
    else
        stop("'ranges' must be a GRanges or GRangesList object")

    geneLengthsInKB <- numBases / 1000
    millionsMapped <- sum(count) / 1000000
    rpm <- count / millionsMapped
    rpm / geneLengthsInKB
}

renewEatonEtAl <-
    function(aln)
{
    ## re-code chromosome
    chr <- chromosome(aln)
    levels(chr) <- "chrXIV"

    ## reverse quality scores, and reverse-complement sequences
    idx <- strand(aln) == "-"

    qual <- quality(quality(aln))
    qual[idx] <- reverse(qual[idx])

    seq <- sread(aln)
    seq[idx] <- reverseComplement(seq[idx])

    ## ShortRead updates objects using 'renew'
    renew(aln, sread=seq, quality=FastqQuality(qual),
          chromosome=chr)
}

## Extend ShortRead

## an additional filter
chastityFilter <- function(.name="Illumina Chastity Filter") 
{
    srFilter(function(x) {
        if(any(rownames(varMetadata(alignData(x))) == "filtering")) {
            alignData(x)[["filtering"]] == "Y"
        } else {
            warning(paste("The '", .name, "' filter is only valid for Illumina reads.", sep=""))
            TRUE
        } 
    }, name = .name)
}

## de-multiplex multiplexed libs
setGeneric("demultiplex",
    function(obj, indexes=NULL, indexes.qty=12, index.length=6,
             edit.dist=2, type=c("independant","within"))
        standardGeneric("demultiplex")
)
setMethod("demultiplex", "AlignedRead",
    function(obj, indexes=NULL, indexes.qty=12, index.length=6, edit.dist=2,
             type=c("independant", "within"))
    {
        type <- match.arg(type)

        ## find top indexes.qty indexes if missing
        if (is.null(indexes)) {
            indexes <-
              switch(type,
                     independant =
                     head(names(sort(table(alignData(obj)[["multiplexIndex"]]),
                                     decreasing=TRUE)), indexes.qty),
                     within =
                     head(names(sort(oligonucleotideFrequency(narrow(sread(obj),
                                                                     start = 1L,
                                                                     width = index.length),
                                                              index.length,
                                                              simplify.as = "collapsed"),
                                     decreasing=TRUE)), indexes.qty))
        }

        ## get the barcodes, according to a certain size
        barcodes <-
          switch(type,
                 independant =
                 DNAStringSet(as.character(alignData(obj)[["multiplexIndex"]])),
                 within = narrow(sread(obj), start = 1L, width = index.length))

        ## just for illumina
        if (type == "independant" && any(nchar(barcodes) > index.length))
            barcodes <- narrow(barcodes, start = 1L, width = index.length)

        ## calculate the edit distance
        uniqueBarcodes <- unique(barcodes)

        negDist <-
          - t(do.call(rbind,
                      lapply(indexes, neditStartingAt, subject=uniqueBarcodes,
                             fixed=FALSE)))
        dimnames(negDist) <- list(as.character(uniqueBarcodes), indexes)

        ok <- which(apply(negDist, 1, max) >= - edit.dist)
        if (length(ok) == 0) {
            stop("no reads have barcodes within 'edit.dist'")
        } else if (length(ok) < length(obj)) {
            warning("dropping ", length(obj) - length(ok),
                    " reads with non-matching barcodes")
            uniqueBarcodes <- uniqueBarcodes[ok]
            negDist <- negDist[ok, , drop=FALSE]
        }

        firstMax <- max.col(negDist, ties.method="first")
        lastMax <- max.col(negDist, ties.method="last")
        ambiguous <- sum(firstMax != lastMax)
        if (ambiguous > 0) {
            warning("randomly placing ", ambiguous,
                    " reads that match more than one barcode equally")
            firstMax <- max.col(negDist, ties.method="random")
        }

        ## split AlignedRead by barcode
        mapping <- split(as.character(uniqueBarcodes), indexes[firstMax])
        objIdx <- split(seq_len(length(obj)), as.character(barcodes))
        select <-
          lapply(mapping, function(x)
                 obj[sort(unlist(objIdx[x], use.names=FALSE))])

        ## decompose reads
        list(reads =
             lapply(select, narrow, start = index.length + 1L),
             barcodes =
             lapply(select, function(x)
                    narrow(sread(x), start = 1L, width = index.length)))
    }
)

library(graph)
library(Rgraphviz)
packages <- c("Rsamtools", "ShortRead",
              "GenomicRanges", "IRanges", "Biostrings",
              "BSgenome", "rtracklayer", "GenomicFeatures")
edgeList <- vector("list", length = length(packages))
names(edgeList) <- packages
edgeList[["IRanges"]] <- list(cex=10)
edgeList[["GenomicRanges"]] <- list(edges = match("IRanges", packages))
edgeList[["Biostrings"]] <- list(edges = match("IRanges", packages))
edgeList[["Rsamtools"]] <- list(edges = match(c("GenomicRanges", "Biostrings"), packages))
edgeList[["ShortRead"]] <- list(edges = match("Rsamtools", packages))
edgeList[["BSgenome"]] <- list(edges = match(c("GenomicRanges", "Biostrings"), packages))
edgeList[["rtracklayer"]] <- list(edges = match("BSgenome", packages))
edgeList[["GenomicFeatures"]] <- list(edges = match("rtracklayer", packages))
pkgSuite <- new("graphNEL", nodes=packages, edgeL=edgeList, edgemode="directed")
renderGraph(layoutGraph(pkgSuite, layoutType="dot",
                        attrs=list(node=list(fontsize=36, shape="plaintext"))))

%\VignetteDepends{}
%\VignetteIndexEntry{R and Bioconductor Packages for Short Read Analysis}
%\VignettePackage{EMBL2010}

\documentclass{beamer}

\usepackage{BioconductorSlides}
\AtBeginSection[]{%
  \begin{frame}<beamer>{Outline}
    \tableofcontents
  \end{frame}}

\SweaveOpts{keep.source=TRUE}

\title{\R{} / \Bioconductor{} Packages for Short Read Analysis}
\author{Martin Morgan (\href{mailto:mtmorgan@fhcrc.org}{mtmorgan@fhcrc.org})}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
%% \institute[EMBL]{}
\date{14-18 June, 2010}


\begin{document}

<<setup, echo=FALSE>>=
options(width = 40)
@ 

\frame{\titlepage}

\begin{frame}{Announcements / Acknowledgments}
  Announcements
  \begin{itemize}
  \item Annual conference in Seattle, 28-30 July (`Developer Day' 28
    July) \url{https://secure.bioconductor.org/BioC2010}
  \item Two positions available -- software and web development
    \url{http://www.fhcrc.org/about/jobs/index.html} and search for
    positions 23129, 23133.
  \end{itemize}
  Bioconductor team
  \begin{itemize}
  \item Patrick Aboyoun, Marc Carlson, Nishant Gopalakrishnan, Herv\'e
    Pag\`es, Chao-Jen Wong
  \item Wolfgang Huber, Vince Carey, Rafael Irizarry, Robert
    Gentleman.
  \end{itemize}
  Resources
  \begin{itemize}
  \item Bioconductor web site \url{http://bioconductor.org}
  \end{itemize}
  
\end{frame}

\section{Work flow}

\subsection{Experiments and Technologies}
\begin{frame}{Experiments and Technologies}
  Sequence-based experiments
  \begin{itemize}
  \item ChIP, Differential expression, RNA-seq, Metagenomic, \ldots
  \end{itemize}
  Technology
  \begin{itemize}
  \item Illumina, Roche / 454, AB SOLiD, Complete Genomics, \ldots
  \item Third-generation: PacBio, Ion Torrent, Oxford Nanopore, \ldots
  \end{itemize}
  Relevant issues in analysis
  \begin{itemize}
  \item Experimental design, replication, sample preparation artifacts
  \end{itemize}
\end{frame}

\subsection{Pre-processing}
\begin{frame}{Pre-processing}
  Vendor and third-party
  \begin{itemize}
  \item Image processing, base calling
  \item Machine quality assessment
  \item Alignment
  \end{itemize}
  \Bioconductor{} packages
  \begin{itemize}
  \item Quality assessment and representation: \Biocpkg{ShortRead},
    \Biocpkg{GenomicRanges}
  \item Read remediation, trimming, primer removal, specialized
    manipulation: \Biocpkg{IRanges}, \Biocpkg{ShortRead},
    \Biocpkg{Biostrings}
  \item Specialized alignment tasks: \Biocpkg{Biostrings},
    \Biocpkg{BSgenome}
  \end{itemize}
\end{frame}

\subsection{Analysis}
\begin{frame}{Analysis}
  Domain-specific, e.g.,
  \begin{itemize}
  \item ChIP-seq: \Biocpkg{chipseq}, \Biocpkg{ChIPseqR},
    \Biocpkg{CSAR}, \Biocpkg{BayesPeak}
  \item Differential expression: \Biocpkg{DESeq}, \Biocpkg{edgeR},
    \Biocpkg{baySeq}
  \item RNA-seq: \Biocpkg{Genominator}
  \end{itemize}
  Examples (`experiment data' packages)
  \begin{itemize}
  \item \Biocdatapkg{EatonEtAlChIPseq}, \Biocdatapkg{leeBamViews} %
  \end{itemize}
\end{frame}

\subsection{Annotation and Integration}
\begin{frame}{Annotation and Integration}
  Annotation
  \begin{itemize}
  \item Gene-centric: \Biocpkg{AnnotationDbi}, \Rpkg{org.*.db},
    \Biocpkg{KEGG.db}, \Biocpkg{GO.db}, \Biocpkg{Category},
    \Biocpkg{GOstats}
  \item Genome coordinate: \Biocpkg{GenomicFeatures},
    \Biocpkg{ChIPpeakAnno}
  \end{itemize}
  Integration
  \begin{itemize}
  \item Digital and microarray differential expression
  \item RNAseq and gene ontology / pathway,  \Biocpkg{goseq}
  \item HapMap, 1000 genomes, UCSC, Sequence Read Archive, GEO,
    ArrayExpress, \Biocpkg{rtracklayer}, \Biocpkg{biomaRt},
    \Biocpkg{Rsamtools}, \Biocpkg{GEOquery}, \Biocpkg{SRAdb}
  \end{itemize}
\end{frame}

\section{Examples (Psuedo-Code)}

\subsection{Quality Assessment}
\begin{frame}[fragile]{Quality Assessment}
<<qa, eval=FALSE>>=
library(ShortRead)
dir <-                 # Input
    "/mnt/fred/solexa/xxx/100524_HWI-EAS88_0005"
sp <- SolexaPath(dir)  # Many other formats
qa <- qa(sp)           # Collate statistics -- slow
rpt <- report(qa)      # Create report 
browseURL(rpt)         # View in browser
@   
\end{frame}

\subsection{454 Microbiome Pre-Processing}
\begin{frame}[fragile]{454 Microbiome Pre-Processing}
<<bar, eval=FALSE>>=
library(ShortRead)
dir <- "/not/public"
bar <- read454(dir)              # Input
code <- narrow(sread(bar), 1, 8) # Extract bar code
aBar <- bar[code == "AAGCGCTT"]  # Subset one bar code
noBar <-                         # Remove bar code
    narrow(aBar, 11, width(aBar)) 
pcrPrimer <- "GGACTACCVGGGTATCTAAT"
trimmed <-                       # Remove primer
    trimLRPatterns(pcrPrimer, noBar, Lfixed=FALSE)
writeFastq(trimmed,              # Output
           file.path(dir, "trimmed.fastq"))
@ 
\end{frame}

\subsection{Differential Expression}
\begin{frame}[fragile]{Differential Expression}
<<DESeq, eval=FALSE>>=
library(DESeq)
tsvFile <-            # Input
    system.file("extra", "TagSeqExample.tab", 
                package="DESeq")
counts <- read.delim(tsvFile, header=TRUE, 
              stringsAsFactors=TRUE, row.names="gene")
condition <- factor(c("T", "T", "T", "Tb", "N", "N"))
cds <- newCountDataSet(counts, condition)
cds1 <-               # Effective library size
    estimateSizeFactors(cds0)
cds2 <-               # Variance, estimated from mean
    estimateVarianceFunctions(cds2)
res <-                # Negative binomial test
    nbinomTest(cds2, "T", "N")
@ 
\end{frame}

\section{ShortRead}

\subsection{Input and exploration}

\begin{frame}[fragile]{\Biocpkg{ShortRead} data input}

<<library, results=hide>>=
library(EatonEtAlChIPseq)
fl <- system.file("extdata", 
  "GSM424494_wt_G2_orc_chip_rep1_S288C_14.mapview.txt.gz",
  package="EatonEtAlChIPseq") 
aln <- readAligned(fl, type = "MAQMapview")
@ 
\end{frame}

\begin{frame}[fragile]{The \Rclass{AlignedRead} class}
<<aln>>=
aln
table(strand(aln), useNA="always")
@ 
\end{frame}

\begin{frame}[fragile]{Accessing reads, base quality, and other data}
<<sread>>=
head(sread(aln), 3)    
@ 
\end{frame}

\begin{frame}[fragile]{Alphabet by cycle}
  Expectation: nucleotide use independent of cycle
<<abc>>=
alnp <- aln[strand(aln) == "+"]
abc <- alphabetByCycle(sread(alnp))
class(abc)
abc[1:6,1:4]
@ 
\end{frame}

\begin{frame}[fragile]{Alphabet by cycle}
  \begin{columns}
    \column{.5\textwidth} 
    \Rfunction{matplot} takes a matrix and plots each column as a set
    of points
<<abc-plot,fig=TRUE,include=FALSE,prefix=FALSE>>=
tabc <- t(abc[1:4,])
matplot(tabc, type="l",
        lty=rep(1, 4))
@ 
    \column{.5\textwidth}
    \includegraphics[width=\textwidth,height=!]{abc-plot.pdf}
  \end{columns}
\end{frame}

\begin{frame}[fragile]{Quality by cycle}
  \begin{columns}
    \column{.45\textwidth} Encoded quality scores can be decoded to
    their numerical values and represented as a matrix. Calculating
    the average of the column means creates a vector of average
    quality scores across cycle.
<<quality-plot,fig=TRUE,include=FALSE,prefix=FALSE>>=
m <- as(quality(alnp), 
        "matrix")
plot(colMeans(m), type="b")
@ 
    \column{.5\textwidth}
    \includegraphics[width=\textwidth,height=!]{quality-plot.pdf}
  \end{columns}
\end{frame}

\subsection{Manipulation}

\begin{frame}[fragile]{Recoding and updating}
  \begin{enumerate}
  \item Access the chromosome information
  \item Extract the chromosome number from the factor level
  \item Recode the chromosome number to roman (!), create new levels,
    and update the chromosome
  \item Update the \Rclass{AlignedRead}
  \end{enumerate}
<<chr-recode>>=
chrom <- chromosome(alnp)
i <- sub("S288C_([[:digit:]]+)", "\\1", levels(chrom))
levels(chrom) <- paste("chr", as.roman(i), sep="")
alnp <- renew(alnp, chromosome=chrom)
@
\end{frame}

%% \subsection{Quality assessment}

%% \begin{frame}[fragile]{Quality assessment}
%%   Two-step process
%%   \begin{enumerate}
%%   \item \Rfunction{qa}: visit each input file and collate
%%     statistics. Long and computationally intensive; can be done in
%%     parallel.
%%   \item \Rfunction{report}: summarize collected statisitcs into an
%%     HTML-based report
%%   \end{enumerate}
%% <<qa-report,eval=FALSE>>=
%% bowtieDir <- "/path/to/alignments"
%% qa <- qa(bowtieDir, ".*map$", type="Bowtie")
%% rpt <- report(qa)
%% browseURL(rpt)
%% @ 
%% \end{frame}

\section{Resources}

\begin{frame}{Resources}
  \Bioconductor{} Web site
  \begin{itemize}
  \item \url{http://bioconductor.org}
  \item `\href{http://bioconductor.org/docs/install/}{Installation}',
    `\href{http://bioconductor.org/packages/release/Software.html}{Software}',
    and `\href{http://bioconductor.org/docs/mailList.html}{Mailing
      lists}' links.
  \end{itemize}
  Help in \R{}
  \begin{itemize}
  \item \Rfunction{help.start()} to view a help browser.
  \item \text{help(package = "Biostrings")}
  \item \texttt{?readAligned}
  \item \Rfunction{browseVignettes("GenomicRanges")}
  \end{itemize}
\end{frame}

\end{document}

%\VignetteDepends{}
%\VignetteIndexEntry{Lab 4: An introduction to Rsamtools}
%\VignetteKeywords{Short read, I/0, samtools}
%\VignettePackage{CSAMA10}
\documentclass[a4paper]{article}

\usepackage{BioconductorVignette}
\newcommand{\Rsamtools}{\Biocpkg{Rsamtools}}
\newcommand{\bam}{\texttt{BAM}}

\title{Lab 4: An Introduction to \Rsamtools}
\author{Martin Morgan\footnote{Fred Hutchinson Cancer Research Center, Seattle, WA 98008}}
\date{14-18 June, 2010}

\begin{document}

\maketitle

<<options,echo=FALSE>>=
options(width=60)
@ 

<<preliminaries>>=
library(Rsamtools)
@ 

\section{Introduction}

The \Rsamtools{} package provides an interface to \bam{} files. \bam{}
files are produced by \software{samtools} and other software, and
represent a flexible format for storing `short' reads aligned to
reference genomes. \bam{} files typically contain sequence and base
qualities, and alignment coordinates and quality measures. \bam{}
files are appealing for several reasons. The format is flexible enough
to represent reads generated and aligned using diverse
technologies. The files are binary so that file access is relatively
efficient. \bam{} files can be indexed, allowing ready access to
localized chromosomal regions. \bam{} files can be accessed remotely,
provided the remote hosting site supports such access and a local
index is available. This means that specific regions of remote files
can be accessed without retrieving the entire (large!) file.  A full
description is available in the \bam{} format specification
(\url{http://samtools.sourceforge.net/SAM1.pdf})

The main purpose of the \Rsamtools{} package is to import \bam{} files
into \R{}. \Rsamtools{} also provides some facility for file access
such as record counting, index file creation, and filtering to create
new files containing subsets of the original. An important use case
for \Rsamtools{} is as a starting point for creating \R{} objects
suitable for a diversity of work flows, e.g., \Rclass{AlignedRead}
objects in the \Biocpkg{ShortRead} package (for quality assessment
and read manipulation), or \Rclass{GappedAlignments} objects in
\Biocpkg{GenomicRanges} package (for RNA-seq and other
applications). Those desiring more functionality are encouraged to
explore \software{samtools} and related software efforts.

\section{Input}

The essential capability provided by \Rsamtools{} is \bam{}
input. This is accomplished with the \Rfunction{scanBam}
function. \Rfunction{scanBam} takes as input the name of the \bam{}
file to be parsed.  In addition, the \Rfunarg{param} argument
determines which genomic coordinates of the \bam{} file, and what
components of each record, will be input. \Rfunarg{param} is an
instance of the \Rclass{ScanBamParam} class. To create a
\Rfunarg{param} object, call \Rfunction{ScanBamParam}. Here we create
a \Rfunarg{param} object to extract reads aligned to three distinct
ranges (one on \Robject{seq1}, two on \Robject{seq2}). From each of read
in those ranges, we specify that we would like to extract the
reference name (\Rcode{rname}, e.g., \Rcode{seq1}), strand, alignment
position, query (i.e., read) width, and query sequence:
<<ScanBamParam>>=
which <- RangesList(seq1=IRanges(1000, 2000),
                    seq2=IRanges(c(100, 1000), c(1000, 2000)))
what <- c("rname", "strand", "pos", "qwidth", "seq")
param <- ScanBamParam(which=which, what=what)
@ 
%% 
Additional information can be found on the help page for
\Rfunction{ScanBamParam}.  Reading the relevant records from the
\bam{} file is accomplished with
<<scanBam, keep.source=TRUE>>=
bamFile <- 
    system.file("extdata", "ex1.bam", package="Rsamtools")
bam <- scanBam(bamFile, param=param)
@ 

Like \Rfunction{scan}, \Rfunction{scanBam} returns a \Robject{list} of
values. Each element of the list corresponds to a range specified by
the \Rfunarg{which} argument to \Rfunction{ScanBamParam}. 
<<scanBam-elts-1>>=
class(bam)
names(bam)
@ 
%% 
Each element is itself a list, containing the elements specified by
the \Rfunarg{what} and \Rfunarg{tag} arguments to
\Rfunction{ScanBamParam}. 
<<scanBam-elts-2>>=
class(bam[[1]])
names(bam[[1]])
@ 
%% 
The elements are either basic \R{} or \Biocpkg{IRanges} data types
<<scanBam-elts-class>>=
sapply(bam[[1]], class)
@ 
%% 
A paradigm for collapsing the list-of-lists into a single list is
<<scanBam-to-IRanges>>=
lst <- lapply(names(bam[[1]]), function(elt) {
    do.call(c, unname(lapply(bam, "[[", elt)))
})
names(lst) <- names(bam[[1]])
@ 
%% 
This might be further transformed, e.g., to a \Rclass{DataFrame} (a
data structure defined in the \Biocpkg{IRanges} package), with
<<lst-to-DataFrame>>=
df <- do.call("DataFrame", lst)
head(df)
@ 

The \bam{} file in the previous example includes an index, represented
by a separate file with extension \texttt{.bai}:
<<indexed-file>>=
list.files(dirname(bamFile), pattern="ex1.bam(.bai)?")
@ 
%% 
Indexing provides two significant benefits. First, an index allows a
\bam{} file to be efficiently accessed by range. A corollary is that
providing a \Rfunarg{which} argument to \Rfunction{ScanBamParam}
requires an index. Second, coordinates for extracting information from
a \bam{} file can be derived from the index, so a portion of a remote
\bam{} file can be retrieved with local access only to the index. For
instance, provided an index file exists on the local computer, it is
possible to retrieve a small portion of a \bam{} file residing on the
1000 genomes HTTP server. The url
\url{ftp://ftp-trace.ncbi.nih.gov/1000genomes/ftp/pilot_data/data/NA19240/alignment/NA19240.chrom6.SLX.maq.SRP000032.2009_07.bam}
points to the \bam{} file corresponding to individual NA19240
chromosome~6 Solexa (Illumina) sequences aligned using MAQ. The remote
file is very large (about 10 GB), but the corresponding index file is
small (about 500 KB). With \Rcode{na19240url} set to the above
address, the following retrieves just those reads in the specified
range
<<bam-remote,eval=FALSE>>=
##
## DO NOT EVALUATE THIS CODE
##
which <- RangesList("6"=IRanges(100000L, 110000L))
param <- ScanBamParam(which=which)
na19240bam <- scanBam(na19240url, param=param)
@ 
%% 
Invoking \Rfunction{scanBam} without an index file, as above, first
retrieves the index file from the remote location, and then queries
the remote file using the index; for repeated queries, it is more
efficient to retrieve the index file first (e.g., with
\Rfunction{download.file}) and then use the local index as an argument
to \Rfunction{scanBam}. Many \bam{} files were created in a way that
causes \Rfunction{scanBam} to report that the ``EOF marker is
absent''; this message can safely be ignored.

\bam{} files may be read by functions in packages other than
\Rsamtools{}. In \Biocpkg{ShortRead}, \Rfunction{readAligned} invoked
with \Rfunarg{type="BAM"} will read \bam{} files in to an
\Rclass{AlignedRead} object. This function takes a \Rfunarg{param}
argument, just as \Rfunction{scanBam}, so the user can control which
portions of the file are input. Similar input facilities are available
through the \Rfunction{readGappedAlignments} function in
\Biocpkg{GenomicRanges}.  

Additional ways of interacting with \bam{} files include
\Rfunction{scanBamHeader} (to extract header information) and
\Rfunction{countBam} (to count records matching \Rfunarg{param}).
\Rfunction{filterBam} filters reads from the source file according to
the criteria of the \Rclass{ScanBamParam} parameter, writing reads
passing the filter to a new file.  The function \Rfunction{indexBam}
creates an index file from a sorted \bam{} file.

\Rfunction{readPileup} reads a \texttt{pileup} file created by
\software{samtools}, importing SNP, indel, or all variants into a
\Rclass{GRanges} object.

\subsection{Large bam files}

\bam{} files can be large, containing more information on more genomic
regions than are of immediate interest or than can fit in memory. The
first strategy for dealing with this is to select, using the
\Rfunarg{what} and \Rfunarg{which} arguments to
\Rfunction{ScanBamParam}, just those portions of the \bam{} file that
are essential to the current analysis, e.g., specifying
\Rcode{what=c(`rname', 'qname', 'pos')} when wishing to calculate
coverage of ungapped reads. 

When selective input of \bam{} files is still too memory-intensive,
the file can be processed in chunks, with each chunk
distilled to the derived information of interest. Chromosomes will
often be the natural chunk to process. For instance, here we write a
summary function that takes a single sequence name (chromosome) as
input, reads in specific information from the \bam{} file, and calculates
coverage over that sequence.
<<summaryFunction>>=
summaryFunction <- 
    function(seqname, bamFile, ...)
{
    param <- ScanBamParam(what=c('pos', 'qwidth'),
                          which=GRanges(seqname, IRanges(1, 1e7)),
                          flag=scanBamFlag(isUnmappedQuery=FALSE))
    x <- scanBam(bamFile, ..., param=param)[[1]]
    coverage(IRanges(x[["pos"]], width=x[["qwidth"]]))
}
@ 
%% 
This might be used as follows; it is an ideal candidate for evaluation
in parallel, e.g., using the \Rpackage{multicore} package and
\Rfunction{srapply} function in \Biocpkg{ShortRead}.  
<<summaryByChromosome>>=
seqnames <- paste("seq", 1:2, sep="")
cvg <- lapply(seqnames, summaryFunction, bamFile)
names(cvg) <- seqnames
cvg
@ 
%% 
The result of the function (a coverage vector, in this case) will
often be much smaller than the input.

\section{Views}

The functions described in the previous section import data in to
\R{}. However, sequence data can be very large, and it does not always
make sense to read the data in immediately. Instead, it can be useful
to marshal \emph{references} to the data into a container and then act
on components of the container.  The \Rclass{BamViews} class provides
a mechanism for creating `views' into a set of \bam{} files. The view
itself is light-weight, containing references to the relevant \bam{}
files and metadata about the view (e.g., the phenotypic samples
corresponding to each \bam{} file).

One way of understanding a \Rclass{BamViews} instance is as a
rectangular data structure. The columns represent \bam{} files (e.g.,
distinct samples). The rows represent ranges (i.e., genomic
coordinates). For instance, a ChIP-seq experiment might identify a
number of peaks of high read counts.

\subsection{Assembling a \Rclass{BamViews} instance}

To illustrate, suppose we have an interest in caffeine metabolism in
humans. The `rows' contain coordinates of genomic regions associated
with genes in a KEGG caffeine metabolism pathway. The `columns'
represent individuals in the 1000 genomes project.  The details of
creating a \Rclass{BamViews} object are described in the
appendix. Here we retrieve archived versions of the genomic ranges we
are interested in (\Robject{bamRanges}) and a vector of \bam{} file
URLs (\Robject{slxMaq09}).
<<BamViews-parts>>=
library(GenomicFeatures)
bamRanges <- local({
    fl <- system.file("extdata", "CaffeineTxdb.sqlite", 
                      package="Rsamtools")
    transcripts(loadFeatures(fl))
})
slxMaq09 <- local({
    fl <- system.file("extdata", "slxMaq09_urls.txt", 
                      package="Rsamtools")
    readLines(fl)
})
@ 
%% 
We now assemble the \Rclass{BamViews} instance from these objects; we
also provide information to annotated the \bam{} files (with the
\Rfunarg{bamSamples} function argument, which is a \Rclass{DataFrame}
instance with each row corresponding to a \bam{} file) and the
instance as a whole (with \Rfunarg{bamExperiment}, a simple named
\Rclass{list} containing information structured as the user sees fit).
<<BamViews-construct, keep.source=TRUE>>=
bamExperiment <- 
    list(description="Caffeine metabolism views on 1000 genomes samples",
         created=date())
bv <- BamViews(slxMaq09, bamRanges=bamRanges, 
               bamExperiment=bamExperiment)
metadata(bamSamples(bv)) <- 
    list(description="Solexa/MAQ samples, August 2009",
         created="Thu Mar 25 14:08:42 2010")
@ 

\subsection{Using \Rclass{BamViews} instances}

The \Rclass{BamViews} object can be queried for its component parts, e.g.,
<<BamViews-query>>=
bamExperiment(bv)
@ 
%% 
More usefully, Methods in \Rsamtools{} are designed to work
with \Rclass{BamViews} objects, retrieving data from all files in the
view. These operations can take substantial time and require reliable
network access.

To illustrate, the following code (not evaluated when this vignette
was created) downloads the index files associated with the
\Robject{bv} object
<<bamIndicies,eval=FALSE>>=
##
## DO NOT EVALUATE THIS CODE
##
bamIndexDir <- tempfile()
indexFiles <- paste(bamPaths(bv), "bai", sep=".")
dir.create(bamIndexDir)
idxFiles <- mapply(download.file, indexFiles,
                   file.path(bamIndexDir, basename(indexFiles)) ,
                   MoreArgs=list(method="curl"))
@ 
%% 
and then queries the 1000 genomes project for reads overlapping our
transcripts; by loading the \Rpackage{multicore} package, we tell
\Rsamtools{} to use as many cores as are available on our machine (the
\Rpackage{multicore} package is not currently -- as of 25 March, 2010
-- reliable on Windows computers)
<<readBamGappedAlignments, eval=FALSE>>=
##
## DO NOT EVALUATE THIS CODE
##
library(multicore)
olaps <- readBamGappedAlignments(bv)
@ 
%% 
The resulting object is about 6 MB in size. To avoid having to
download this data each time the vignette is run, we instead load it
from disk
%% 
<<olaps>>=
load(system.file("extdata", "olaps.Rda", package="Rsamtools"))
olaps
head(olaps[[1]])
@ 
%% 
There are \Sexpr{length(olaps[[1]])} reads in
\verb|\Sexpr{names(olaps)[[1]]}| overlapping at least one of our
transcripts. It is easy to explore this object, for instance
discovering the range of read widths in each individual.
<<read-lengths>>=
head(t(sapply(olaps, function(elt) range(qwidth(elt)))))
@ 

Suppose we were particularly interested in the first transcript, which
has a transcript id
\Sexpr{elementMetadata(bamRanges(bv))[["tx_name"]][1]}. Here we
extract reads overlapping this transcript from each of our samples. As
a consequence of the protocol used, reads aligning to either strand
could be derived from this transcript. For this reason, we set the
strand of our range of interest to \texttt{*}. We use the
\Rfunction{endoapply} function, which is like \Rfunction{lapply} but
returns an object of the same class (in this case,
\Sexpr{as.vector(class(olaps))}) as its first argument.
<<focal>>=
rng <- bamRanges(bv)[1]
strand(rng) <- "*"
olap1 <- endoapply(olaps, subsetByOverlaps, rng)
olap1
head(olap1[[24]])
@ 
%% 
To carry the example a little further, we calculate coverage of each
sample:
<<olap-cvg, keep.source=TRUE>>=
minw <- min(sapply(olap1, function(elt) min(start(elt))))
maxw <- max(sapply(olap1, function(elt) max(end(elt))))
cvg <- endoapply(olap1, coverage,
                 shift=-start(ranges(bamRanges[1])),
                 width=width(ranges(bamRanges[1])))
cvg
cvg[[1]][["15"]] # sample 1, chromosome 15
@ 
%% 
Since the example includes a single region of uniform width across all
samples, we can easily create a coverage matrix with rows representing
nucleotide and columns sample and, e.g., document variability between
samples and nucleotides
<<olap-cvg-as-m>>=
m <- matrix(unlist(lapply(cvg, lapply, as.vector)),
            ncol=length(cvg))
summary(rowSums(m))
summary(colSums(m))
@ 

\section{Directions}

This vignette has summarized facilities in the \Rsamtools{}
package. Important additional packages include \Biocpkg{GenomeRanges}
(for representing and manipulating gapped alignments),
\Biocpkg{ShortRead} for I/O and quality assessment of ungapped short
read alignments, \Biocpkg{Biostrings} and \Biocpkg{BSgenome} for DNA
sequence and whole-genome manipulation, \Biocpkg{IRanges} for
range-based manipulation, and \Biocpkg{rtracklayer} for I/O related
to the UCSC genome browser. Users might also find the interface to the
integrative genome browser (IGV) in \Biocpkg{SRAdb} useful for
visualizing \bam{} files.

<<sessionInfo>>=
packageDescription("Rsamtools")
sessionInfo()
@ 

\appendix

\section{Assembling a \Rclass{BamViews} instance}

\emph{Note} The code in this appendix requires reliable high-speed
internet access; do not evaluate during the lab.

\subsection{Genomic ranges of interest}

We identify possible genes that KEGG associates with caffeine
metabolism:
<<caffeine-kegg>>=
library(KEGG.db)
kid <- revmap(KEGGPATHID2NAME)[["Caffeine metabolism"]]
egid <- KEGGPATHID2EXTID[[sprintf("hsa%s", kid)]]
@ 
%% 
Then we use the \Biocpkg{biomaRt} package to translate Entrez
identifiers to Ensembl transcript ids, and use these to create a small
data base (using the \Biocpkg{GenomicFeatures} packages) of features
we are interested in
<<caffeine-txdb,eval=FALSE>>=
library(biomaRt)
mart <- useMart("ensembl", "hsapiens_gene_ensembl")
ensid <- getBM(c("ensembl_transcript_id"), filters="entrezgene",
               values=egid, mart=mart)[[1]]
library(GenomicFeatures)
txdb <- makeTranscriptDbFromBiomart(transcript_ids=ensid)
@ 
<<caffeine-txdb-load,echo=FALSE>>=
library(GenomicFeatures)
fl <- system.file("extdata", "CaffeineTxdb.sqlite", 
                  package="Rsamtools")
txdb <- loadFeatures(fl)
@ 
%% 
Transcript genomic locations are contained in \Robject{txdb}; we will
use those as the ranges for the \Rclass{BamViews}
<<txdb-transcripts>>=
bamRanges <- transcripts(txdb)
@ 

\subsection{BAM files}

\emph{Note}: The following operations were performed at the time the
vignette was written; location of on-line resources, in particular the
organization of the 1000 genomes \bam{} files, may have changed.

We are interested in collecting the URLs of a number of \bam{} files
from the 1000 genomes project. Our first goal is to identify files
that might make for an interesting comparison.  First, let's visit the
1000 genomes FTP site and discover available files. We'll use the
\Biocpkg{RCurl} package to retrieve the names of all files in an
appropriate directory
<<bam-avail, keep.source=TRUE, eval=FALSE>>=
library(RCurl)
ftpBase <- 
    "ftp://ftp-trace.ncbi.nih.gov/1000genomes/ftp/pilot_data/data/"
indivDirs <- 
    strsplit(getURL(ftpBase, ftplistonly=TRUE), "\n")[[1]]
alnDirs <- 
    paste(ftpBase, indivDirs, "/alignment/", sep="")
urls0 <- 
    strsplit(getURL(alnDirs, dirlistonly=TRUE), "\n")
@ 
%% 
From these, we exclude directories without any files in them, select
only the \bam{} index (extension \texttt{.bai}) files, and choose those
files that exactly six \texttt{'.'} characters in their name.
<<bam-index,eval=FALSE>>=
urls <- urls[sapply(urls0, length) != 0]
fls0 <- unlist(unname(urls0))
fls1 <- fls0[grepl("bai$", fls0)]
fls <- fls1[sapply(strsplit(fls1, "\\."), length)==7]
@ 
%% 
After a little exploration, we focus on those files obtained form
Solexa sequencing, aligned using \texttt{MAQ}, and archived in August,
2009; we remove the \texttt{.bai} extension, so that the URL refers to
the underlying file rather than index. There are 24 files.
<<slxMaq09,eval=FALSE>>=
urls1 <- 
    Filter(function(x) length(x) != 0,
           lapply(urls, 
                  function(x) x[grepl("SLX.maq.*2009_08.*bai$", x)]))
slxMaq09.bai <- 
   mapply(paste, names(urls1), urls1, sep="", USE.NAMES=FALSE)
slxMaq09 <- sub(".bai$", "", slxMaq09.bai) #$
@ 

As a final step to prepare for using a \Rclass{BamViews} file, we
create local copies of the \emph{index} files. The index files are
relatively small (about 190 Mb total).
<<bamIndicies,eval=FALSE>>=
bamIndexDir <- tempfile()
dir.create(bamIndexDir)
idxFiles <- mapply(download.file, slxMaq09.bai, 
                   file.path(bamIndexDir, basename(slxMaq09.bai)) ,
                   MoreArgs=list(method="curl"))
@ 

\end{document}

%\VignetteDepends{IRanges, GenomicRanges, Biostrings}
%\VignetteIndexEntry{The IRanges, GenomicRanges, and Biostrings packages}
%\VignettePackage{CSAMA10}

\documentclass{beamer}

\usepackage{BioconductorSlides}
\SweaveOpts{keep.source=TRUE, eps=FALSE, width=9, height=3}

\title{\Biocpkg{IRanges}, \Biocpkg{GenomicRanges}, and \Biocpkg{Biostrings}}
\subtitle{\Bioconductor{} Infrastructure Packages for Sequence Analysis}
\author{Patrick Aboyoun}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{14-18 June, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 64)
library(GenomicRanges)
library(Biostrings)
library(CSAMA10)
plotGRanges <- function(x, xlim = x, main = deparse(substitute(x)),
                       sep = 0.5, ...) 
{
  height <- 1
  if (is(xlim, "Ranges") || is(xlim, "GRanges"))
    xlim <- c(min(start(xlim)), max(end(xlim)))
  bins <- disjointBins(IRanges(start(x), end(x) + 1))
  plot.new()
  plot.window(xlim, c(0, max(bins)*(height + sep)))
  ybottom <- bins * (sep + height) - height
  col <- ifelse(as.vector(strand(x) == "+"), "blue",
         ifelse(as.vector(strand(x) == "-"), "red", "purple"))
  rect(start(x) - 0.5, ybottom, end(x) + 0.5, ybottom + height, col = col, ...)
  title(main)
  axis(1)
}
@

\frame{\titlepage}

\section{Introduction}

\begin{frame}[t]
  \frametitle{Motivation}
  \begin{block}{Short term: Ad-hoc sequence analysis tools}
    \begin{itemize}
      \item QA/QC for NGS experiments.
      \item Finding TF binding sites (ChIP-seq) or \textit{de novo}
        exon locations (RNA-seq) using coverage of alignments across
        a genome. (peak finding)
      \item Motif finding (e.g. PWM) for TF binding sites from ChIP-seq.
      \item Finding differentially expressed genes in RNA-seq.
      \item Comparing prevalence of known alternative spliced transcripts
        in RNA-seq.
      \item Finding \textit{de novo} alternative splicing of transcripts
        in RNA-seq.
      \item etc.
    \end{itemize}
  \end{block}
  \begin{block}{Long term: Sequence analysis pipelines}
    Work in progress and outside scope of the labs.
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Example: Comparing transcript isoforms in RNA-seq}
{\small
\begin{verbatim}
> txExonOverlapCountsGroupedByGene
CompressedSplitDataFrameList of length 15160 
$FBgn0000556 
DataFrame with 2 rows and 3 columns 
      tx_id             exon_counts total_count 
  <integer> <CompressedIntegerList>   <integer> 
1      5375                33,1099         1132 
2      5374                 0,1099         1099 

$FBgn0000559 
DataFrame with 3 rows and 3 columns 
      tx_id             exon_counts total_count 
  <integer> <CompressedIntegerList>   <integer> 
1      3681            10,52,92,...         541 
2      3679             0,52,92,...         531 
3      3680             0,52,92,...         531 

... 
<15158 more elements> 
\end{verbatim}
}
\end{frame}

\begin{frame}[t]
  \frametitle{\Bioconductor{} Sequence Packages}
\begin{figure}[ht]
 \centering
  \includegraphics[width=4in,height=3in]{packageStack}
\end{figure}
\end{frame}

\begin{frame}[t]
  \frametitle{\Bioconductor{} Sequence Infrastructure Packages}
  \begin{block}{\Biocpkg{IRanges}}
    \begin{itemize}
      \item Long sequences (compressed \& pointer referenced)
      \item Views on long sequences
      \item Integer interval tools (e.g. interval overlap)
      \item Genomic intervals I (\Rclass{RangedData})
    \end{itemize}
  \end{block}

  \begin{block}{\Biocpkg{GenomicRanges}}
    \begin{itemize}
      \item Genomic intervals II (\Rclass{GenomicRanges})
      \item Discontiguous genomic interval sets (\Rclass{GenomicRangesList})
    \end{itemize}
  \end{block}

  \begin{block}{\Biocpkg{Biostrings}}
    \begin{itemize}
      \item Long DNA/RNA/amino acids sequences
      \item Sequence \& PWM matching and pairwise alignment tools
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{\Bioconductor{} Sequence Infrastructure Classes}
  \begin{block}{Ranges (as sequences \& intervals)}
    \Rclass{IRanges}
  \end{block}

  \begin{block}{Genomic intervals with data}
    \Rclass{GRanges}, \Rclass{RangedData}
  \end{block}

  \begin{block}{Genomic interval sets (e.g. spliced transcripts)}
    \Rclass{GRangesList}
  \end{block}

  \begin{block}{Long piecewise constant sequences}
    \Rclass{Rle}, \Rclass{RleList}
  \end{block}

  \begin{block}{Long (biological) strings}
    \Rclass{DNAString}, \Rclass{RNAString}, \Rclass{AAString},
    \Rclass{BString}, \Rclass{DNAStringSet}, \ldots
  \end{block}

  \begin{block}{Views on long sequences}
    \Rclass{RleViews}, \Rclass{RleListViews}, \Rclass{XStringViews},
    \ldots
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{Concept I: Run-Length Encoding (RLE)}
  \begin{block}{Issue}
    \begin{itemize}
      \item Chromosomes can be hundreds of million of base
            pairs long, making them hard to manage in computer
            memory.
      \item Fortunately, coverage vectors tend to follow an
            integer step function.
    \end{itemize}
  \end{block}

  \begin{block}{Solution}
    \begin{itemize}
      \item Run-length encoding (RLE) is a common compression
            technique for storing long sequences with lengthy
            repeats.
      \item An RLE couples values with run lengths, e.g. the
            vector 0, 0, 0, 1, 1, 2 would be represented as
            (3) 0's, (2) 1's, and (1) 2.
      \item The \Biocpkg{IRanges} package uses the
            \Rclass{Rle} and \Rclass{RleList} classes to house
            coverage vectors.
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{Concept II: Sequence Views}
  \begin{block}{Issue}
    \begin{itemize}
      \item Chromosomes can be hundreds of million of base
            pairs long, making subsequence selection inefficient.
    \end{itemize}
  \end{block}

  \begin{block}{Solution}
    \begin{itemize}
      \item Store the original sequence using a pass-by-reference
            semantic.
      \item Associate ranges with the sequence to select subsequence.
      \item Example:
        \begin{itemize}
          \item 7007-letter sequence:
            \Rcode{$<<$SNIP-3000$>>$AGATTCA$<<$SNIP-4000$>>$}
          \item View range: \Rcode{[3001, 3007]}
          \item $=>$ 7-letter subsequence: \Rcode{AGATTCA}
        \end{itemize}
    \end{itemize}
  \end{block}
\end{frame}


\section{Genomic Intervals with Data}

\begin{frame}[t,fragile]
  \frametitle{Naive representation for intervals with data}
  \begin{block}{Data characteristics}
    \begin{itemize}
      \item Genomic coordinates consist of chromosome, position,
        and potentially strand information
      \item May have additional values, such as GC content or
        alignment coverage
    \end{itemize}
  \end{block}

  \begin{block}{\Rclass{data.frame} approach}
{\small
<<naive-GRanges-1>>=
chr <- c("chr1", "chr2", "chr1")
strand <- c("+", "+", "-")
start <- c(3L, 4L, 1L)
end <- c(7L, 5L, 3L)
naive <- data.frame(chr = chr, strand = strand,
                    start = start, end = end)
@
}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{BioC representations for intervals with data}
  \begin{block}{\Rclass{GRanges}}
    \begin{itemize}
      \item Used by \Biocpkg{GenomicFeatures}, a transcript annotation
        generator
      \item Intervals not required to be grouped by chromosome/contig
      \item Methods strand aware
      \item \Rclass{GRangesList} class can hold exons within spliced
        transcripts
    \end{itemize}
  \end{block}
\vskip12pt
  \begin{block}{\Rclass{RangedData}}
    \begin{itemize}
      \item Used by \Biocpkg{rtracklayer}, a genome browser interface
      \item Intervals grouped by chromosome/contig
      \item Methods strand unaware
      \item Preceded \Rclass{GRanges} class
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{GRanges} construction}
  \begin{block}{\Rclass{GRanges} constructor}
    \begin{itemize}
      \item Instances are created using the \Rfunction{GRanges}
        constructor.
      \item Starts and ends are wrapped in an \Rclass{IRanges}
        constructor.
      \item Chromosome/contig supplied to \Rfunarg{seqnames}
        argument.
      \item Underlying sequence lengths can be suppled to
        \Rfunarg{seqlengths} argument.
    \end{itemize}
  \end{block}

  \begin{block}{\Rclass{GRanges} example}
{\small
<<GRanges-construction>>=
bioc <- GRanges(seqnames = chr,
                ranges = IRanges(start = start, end = end),
                strand = strand,
                seqlengths = c("chr1" = 24, "chr2" = 18))
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{GRanges} display}
  \begin{block}{\Rclass{GRanges} \Rfunction{show} method}
{\small
<<GRanges-display>>=
bioc
@
}
  \end{block}

  \begin{block}{Note}
    \begin{itemize}
      \item Optional interval data would appear to the right of
        \Rcode{|} divider.
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{GRanges} class decomposition}
  \begin{block}{\Rclass{GRanges} slots}
{\footnotesize
<<GRanges-slots>>=
getSlots("GRanges")
@
}
  \end{block}

  \begin{block}{Notes}
    \begin{itemize}
      \item If (mostly) sorted, \Rclass{Rle} vectors reduce memory
        usage and provide faster group selection
      \item \Rfunarg{elementMetadata} holds optional interval data
      \item \Rfunarg{metadata} holds optional whole object info
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{Interval operations}
  \begin{block}{Intra-interval}
    \Rfunction{flank}, \Rfunction{resize}, \Rfunction{shift}
  \end{block}

  \begin{block}{Inter-interval I}
    \Rfunction{disjoin}, \Rfunction{gaps}, \Rfunction{reduce},
    \Rfunction{range}
  \end{block}

  \begin{block}{Inter-interval II}
    \Rfunction{coverage}
  \end{block}

  \begin{block}{Between two interval sets I}
    \Rfunction{union}, \Rfunction{intersect}, \Rfunction{setdiff}
  \end{block}

  \begin{block}{Between two interval sets II}
    \Rfunction{punion}, \Rfunction{pintersect}, \Rfunction{psetdiff}
  \end{block}

  \begin{block}{Between two interval sets III}
    \Rfunction{findOverlaps}, \Rfunction{countOverlaps}, \Rfunction{\%in\%},
    \Rfunction{match}
  \end{block}

  \begin{block}{Low level}
    \Rfunction{start}, \Rfunction{end}, \Rfunction{width}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Creating a new \Rclass{GRanges} object}
  \begin{block}{New object to use in interval operations}
{\small
<<ranges-construct>>=
ir <- IRanges(c(1, 8, 14, 15, 19, 34, 40), 
              width=c(12, 6,  6, 15, 6, 2, 7))
strand <- rep(c("+", "-"), c(4,3))
grngs <- GRanges(seqnames = "chr1", ranges = ir,
                 strand = strand,
                 seqlengths = c("chr1" = 50))
@
}
<<ranges-plot, fig=TRUE, echo=FALSE>>=
plotGRanges(grngs)
@
{\tiny
\newline
  blue = positive strand, red = negative strand
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{GRanges} subsetting}
  \begin{block}{seqselect}
{\small
<<ranges-subset>>=
seqselect(grngs, strand(grngs) == "-")
@
}
  \end{block}

  \begin{block}{Other functions}
    \Rfunction{[}, \Rfunction{head}, \Rfunction{tail},
    \Rfunction{window}, \Rfunction{subset},
    \Rfunction{subsetByOverlaps}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Intra-interval (1/2)}
  \begin{block}{Shifting intervals}
  If your interval bounds are off by 1, you can shift them.
{\small
<<ranges-shift>>=
shift(grngs, 1)
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Intra-interval (2/2)}
  \begin{block}{Resizing intervals}
  ``Growing" alignment intervals to an estimated fragment length.
{\small
<<ranges-resize-1>>=
resize(grngs, 10)
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Inter-interval I}
<<ranges-reduce-plot, echo=FALSE, fig=TRUE>>=
plotGRanges(reduce(grngs))
@
\newline
<<ranges-gaps-plot, echo=FALSE, fig=TRUE>>=
plotGRanges(gaps(grngs))
@
\newline
<<ranges-disjoin-plot, echo=FALSE, fig=TRUE>>=
plotGRanges(disjoin(grngs))
@
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Overlap detection}
  \begin{block}{Finding interval overlaps}
    \Rfunction{findOverlap} and \Rfunction{countOverlaps}
    produce a mapping and a tabulation of interval overlaps,
    respectively
  \end{block}
{\small
<<ranges-overlap>>=
ol <- findOverlaps(grngs, reduce(grngs))
as.matrix(ol)
countOverlaps(reduce(grngs), grngs)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Elementwise counts of overlapping intervals}
  \begin{block}{Coverage}
    \begin{itemize}
      \item \Rfunction{coverage} counts number of ranges over each position
      \item Subset by strand to get stranded coverage
    \end{itemize}
  \end{block}
  \begin{block}{}
{\small
<<ranges-coverage>>=
cover <- coverage(grngs)
@
}
<<ranges-coverage-plot, height=4, echo=FALSE, fig=TRUE>>=
cover <- coverage(grngs)
plotGRanges(grngs)
cover <- as.integer(cover[["chr1"]])
mat <- cbind(seq_along(cover)-0.5, cover)
d <- diff(cover) != 0
mat <- rbind(cbind(mat[d,1]+1, mat[d,2]), mat)
mat <- mat[order(mat[,1]),]
lines(mat, col="black", lwd=4)
axis(2)
@
  \end{block}
\end{frame}


\section{Coverage and Other Piecewise Constant Measures}

\begin{frame}[t]
  \frametitle{Piecewise constant measures}
  \begin{block}{Issue restated}
    \begin{itemize}
      \item The number of genomic positions in a genome is often in the
        billions for higher organisms, making it challenging to represent
        in memory.
      \item Some data across a genome tend to be sparse (i.e. large
        stretches of ``no information")
    \end{itemize}
  \end{block}

  \begin{block}{\Rclass{Rle} and \Rclass{RleList} classes}
    \begin{itemize}
      \item Solve the set of problems for positional measures that tend
      to have consecutively repeating values.
      \item \emph{Do not} address the more general problem of positional
        measures that constantly fluxuate, such as conservation scores.
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Numerous \Rclass{Rle} methods (1/2)}
{\scriptsize
\begin{verbatim}
 [1] "!"             "["             "[<-"           "%in%"         
 [5] "aggregate"     "as.character"  "as.complex"    "as.data.frame"
 [9] "as.factor"     "as.integer"    "as.logical"    "as.numeric"   
[13] "as.raw"        "as.vector"     "c"             "chartr"       
[17] "coerce"        "Complex"       "cor"           "cov"          
[21] "diff"          "end"           "findRange"     "findRun"      
[25] "gsub"          "IQR"           "is.na"         "is.unsorted"  
[29] "length"        "levels"        "levels<-"      "mad"          
[33] "match"         "Math"          "Math2"         "mean"         
[37] "median"        "nchar"         "nrun"          "Ops"          
[41] "paste"         "pmax"          "pmax.int"      "pmin"         
[45] "pmin.int"      "quantile"      "rep"           "rep.int"      
[49] "rev"           "runLength"     "runLength<-"   "runmean"      
[53] "runmed"        "runq"          "runsum"        "runValue"     
[57] "runValue<-"    "runwtsum"      "sd"            "seqselect"    
[61] "seqselect<-"   "shiftApply"    "show"          "slice"        
[65] "smoothEnds"    "sort"          "split"         "splitRanges"  
[69] "start"         "sub"           "substr"        "substring"    
[73] "summary"       "Summary"       "table"         "tolower"      
[77] "toupper"       "unique"        "var"           "Views"        
[81] "which"         "width"         "window"       
\end{verbatim}
}
\end{frame}

\begin{frame}[t]
  \frametitle{Numerous \Rclass{Rle} methods (2/2)}
{\small
  \begin{block}{\Rfunction{Arith}}
    \Rfunction{+}, \Rfunction{-}, \Rfunction{*}, \Rfunction{\^},
    \Rfunction{\%\%}, \Rfunction{\%/\%}, \Rfunction{/}
  \end{block}
  \begin{block}{\Rfunction{Compare}}
    \Rfunction{==}, \Rfunction{>}, \Rfunction{<}, \Rfunction{!=}, 
    \Rfunction{<=}, \Rfunction{>=}
  \end{block}
  \begin{block}{\Rfunction{Logic}}
    \Rfunction{\&}, \Rfunction{|}
  \end{block}
  \begin{block}{\Rfunction{Math}}
    \Rfunction{abs}, \Rfunction{sign}, \Rfunction{sqrt},
    \Rfunction{ceiling}, \Rfunction{floor}, \Rfunction{trunc},
    \Rfunction{cummax}, \Rfunction{cummin}, \Rfunction{cumprod},
    \Rfunction{cumsum}, \Rfunction{log}, \Rfunction{log10},
    \Rfunction{log2}, \Rfunction{log1p},  \Rfunction{acos},
    \Rfunction{acosh}, \Rfunction{asin}, \Rfunction{asinh}, \ldots
  \end{block}
  \begin{block}{\Rfunction{Math2}}
    \Rfunction{round}, \Rfunction{signif}
  \end{block}
  \begin{block}{\Rfunction{Summary}}
    \Rfunction{max}, \Rfunction{min}, \Rfunction{range},
    \Rfunction{prod}, \Rfunction{sum}, \Rfunction{any},
    \Rfunction{all}
  \end{block}
  \begin{block}{\Rfunction{Complex}}
    \Rfunction{Arg}, \Rfunction{Conj}, \Rfunction{Im},
    \Rfunction{Mod}, \Rfunction{Re}
  \end{block}
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Coverage example}
  Coverage from a \textit{Saccharomyces cerevisiae} (Yeast) experiment
  contained in two objects \Robject{posCover} \& \Robject{negCover}
<<coverage-data-1, echo=FALSE>>=
data(posCover)
data(negCover)
@
{\footnotesize
<<coverage-data-2>>=
c(class(posCover), class(negCover))
posCover[["chrI"]]
negCover[["chrI"]]
posCover[["chrI"]] + negCover[["chrI"]]
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Plotting coverage}
  \begin{block}{Custom function}
{\footnotesize
<<plotCoverage>>=
plotCoverage <-
function(x, chrom, start=1, end=length(x[[chrom]]), col="blue",
         xlab="Index", ylab="Coverage", main=chrom)
{
    xWindow <- as.vector(window(x[[chrom]], start, end))
    x <- start:end
    xlim <- c(start, end)
    ylim <- c(0, max(xWindow))
    plot(x = start, y = 0, xlim = xlim, ylim = ylim,
         xlab = xlab, ylab = ylab, main = main, type = "n")
    polygon(c(start, x, end), c(0, xWindow, 0), col = col)
}
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Plotting coverage on one strand}
\begin{block}{Plotting chr1+ coverage}
{\small
<<cover-all-chr1-pos,fig=TRUE,include=FALSE,prefix=FALSE,width=8,height=5>>=
plotCoverage(posCover, "chrI")
@
}
\end{block}
\begin{figure}[ht]
  \centering
  \includegraphics[width=4in,height=2.5in]{cover-all-chr1-pos}
\end{figure}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Plotting stranded coverage}
  \begin{block}{Custom function}
{\footnotesize
<<plotCoverage>>=
plotCoverageStrands <-
function(pos, neg, chrom, start=1, end=length(pos[[chrom]]),
         pos.col="blue", neg.col="red", xlab="Index",
         ylab="Coverage", main=chrom)
{
    posWindow <- as.vector(window(pos[[chrom]], start, end))
    negWindow <- as.vector(window(neg[[chrom]], start, end))
    x <- start:end
    xlim <- c(start, end)
    ylim <- c(-1, 1) * min(max(posWindow), max(negWindow))
    plot(x = start, y = 0, xlim = xlim, ylim = ylim,
         xlab = xlab, ylab = ylab, main = main, type = "n")
    polygon(c(start, x, end), c(0, posWindow, 0), col = pos.col)
    polygon(c(start, x, end), c(0, - negWindow, 0), col = neg.col)
}
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Plotting coverage on both strands}
\begin{block}{Plotting chr1 coverage, both strands}
{\small
<<cover-all-chr1,fig=TRUE,include=FALSE,prefix=FALSE,width=8,height=5>>=
plotCoverageStrands(posCover, negCover, "chrI")
@
}
\end{block}
\begin{figure}[ht]
  \centering
  \includegraphics[width=4in,height=2.5in]{cover-all-chr1}
\end{figure}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Plotting Coverage on both strands}
\begin{block}{Plotting chr1 coverage, both strands}
{\footnotesize
<<cover-window-chr1,fig=TRUE,include=FALSE,prefix=FALSE,width=8,height=5>>=
plotCoverageStrands(posCover, negCover, "chrI", 135000, 145000)
@
}
\end{block}
\begin{figure}[ht]
  \centering
  \includegraphics[width=4in,height=2.25in]{cover-window-chr1}
\end{figure}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Smoothing coverage}
\begin{block}{Running window mean}
{\scriptsize
<<cover-smooth-chr1,fig=TRUE,include=FALSE,prefix=FALSE,width=8,height=5>>=
posSmoothCover <- round(runmean(posCover, 75, endrule = "constant"))
negSmoothCover <- round(runmean(negCover, 75, endrule = "constant"))
plotCoverageStrands(posSmoothCover,negSmoothCover,"chrI",135000,145000)
@
}
\end{block}
\begin{figure}[ht]
  \centering
  \includegraphics[width=4in,height=2.25in]{cover-smooth-chr1}
\end{figure}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Combining coverage}
\begin{block}{Combining coverage using "parallel" minimums}
{\small
<<combined-coverage>>=
combSmoothCover <- mendoapply(pmin,
                              posSmoothCover,
                              negSmoothCover)
identical(class(posSmoothCover), class(combSmoothCover))
@
}
\end{block}
  \begin{itemize}
    \item The \Rfunction{mendoapply} function defined in
      \Biocpkg{IRanges} packages as a member of the \Rfunction{apply}
      family.
    \begin{itemize}
      \item Performs elementwise operations across multiple
        inputs of the same type.
      \item Returns an object of the same type as the inputs.
    \end{itemize}
    \item The minimum coverage value on either strand can be
      computed using \Rfunction{pmin}.
  \end{itemize}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Plotting combined coverage}
\begin{block}{Plotting chr1, combined strands}
{\scriptsize
<<cover-comb-chr1,fig=TRUE,include=FALSE,prefix=FALSE,width=8,height=5>>=
plotCoverage(combSmoothCover, "chrI", 135000, 145000)
@
}
\end{block}
\begin{figure}[ht]
  \centering
  \includegraphics[width=4in,height=2.5in]{cover-comb-chr1}
\end{figure}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Island selection}
{\scriptsize
<<slice>>=
islands <- slice(combSmoothCover, lower=1)
islandsWithWidePeaks <- islands[viewMaxs(islands) >= 8L &
                                width(islands) >= 500L]
islandsWithWidePeaks
@
}
\end{frame}

\begin{frame}[fragile]
  \frametitle{Common methods for \Rclass{Views} objects}
  \begin{itemize}
    \item Subset via \Rfunction{[}, \Rfunction{[[}, etc.
    \item Manage edge cases via \Rfunction{trim} \& \Rfunction{restrict}
    \item \Rclass{Ranges} operations such as \Rfunction{start},
      \Rfunction{end}, \Rfunction{width}, etc.
    \item Perform within view calculations via \Rfunction{viewSums},
      \Rfunction{viewMins}, \Rfunction{viewMaxs}, \Rfunction{viewWhichMins},
      \Rfunction{viewWhichMaxs}, \Rfunction{viewApply} 
  \end{itemize}
\end{frame}


\section{Long Biological Strings}

\begin{frame}[t,fragile]
  \frametitle{Long biological string framework}
  \begin{block}{Biostrings string types}
{\scriptsize
<<XString-subclasses>>=
library(Biostrings)
names(completeSubclasses(getClass("XString")))
@
}
  \end{block}

  \begin{block}{DNA}
{\scriptsize
<<DNAString>>=
data(yeastSEQCHR1)
c(class(yeastSEQCHR1), nchar(yeastSEQCHR1))
yeast1 <- DNAString(yeastSEQCHR1)
yeast1
IUPAC_CODE_MAP
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{List of strings}
  \begin{block}{Biostrings string list types}
{\footnotesize
<<XStringSet-subclasses>>=
head(names(completeSubclasses(getClass("XStringSet"))), 4)
@
}
  \end{block}

  \begin{block}{DNA strings}
{\footnotesize
<<DNAString>>=
data(srPhiX174)
length(srPhiX174)
head(srPhiX174, 3)
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{XString class decomposition}
  \begin{block}{\Rclass{XString} slots}
{\scriptsize
<<GRanges-slots>>=
getSlots("XString")
getSlots("XStringSet")
@
}
  \end{block}

  \begin{block}{Notes}
    \begin{itemize}
      \item \Rfunarg{shared}, \Rfunarg{offset}, \Rfunarg{length},
        \Rfunarg{pool}, and \Rfunarg{ranges} slots regulate
        pass-by-reference semantic.
      \item \Rfunarg{metadata} slot can be used to hold annotation
        information.
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{Basic string utilities}
  \begin{block}{Subsequence selection}
    \Rfunction{subseq}, \Rfunction{Views}
  \end{block}

  \begin{block}{Letter frequencies}
    \Rfunction{alphabetFrequency},
    \Rfunction{dinucleotideFrequency},
    \Rfunction{trinucleotideFrequency},
    \Rfunction{oligonucleotideFrequency},
    \Rfunction{letterFrequencyInSlidingView},
    \Rfunction{uniqueLetters}
  \end{block}

  \begin{block}{Letter consensus}
    \Rfunction{consensusMatrix}, \Rfunction{consensusString}
  \end{block}

  \begin{block}{Letter transformation}
    \Rfunction{reverse}, \Rfunction{complement},
    \Rfunction{reverseComplement}, \Rfunction{translate},
    \Rfunction{chartr}
  \end{block}

  \begin{block}{I/O}
    \Rfunction{read.DNAStringSet}, \Rfunction{read.RNAStringSet},
    \Rfunction{read.AAStringSet}, \Rfunction{read.BStringSet},
    \Rfunction{write.XStringSet}, \Rfunction{save.XStringSet}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{String matching/alignment utilities}
  \begin{block}{\Rfunction{matchPDict}}
    \Rfunction{matchPDict}, \Rfunction{countPDict},
    \Rfunction{whichPDict}, \Rfunction{vmatchPDict},
    \Rfunction{vcountPDict}, \Rfunction{vwhichPDict}
  \end{block}

  \begin{block}{\Rfunction{vmatchPattern}}
    \Rfunction{matchPattern}, \Rfunction{countPattern},
    \Rfunction{vmatchPattern}, \Rfunction{vcountPattern},
    \Rfunction{neditStartingAt}, \Rfunction{neditEndingAt},
    \Rfunction{isMatchingStartingAt},
    \Rfunction{isMatchingEndingAt},
    \Rfunction{which.isMatchingStartingAt},
    \Rfunction{which.isMatchingEndingAt}
  \end{block}

  \begin{block}{\Rfunction{pairwiseAlignment}}
    \Rfunction{pairwiseAlignment}, \Rfunction{stringDist}
  \end{block}

  \begin{block}{\Rfunction{matchPWM}}
    \Rfunction{matchPWM}, \Rfunction{countPWM}
  \end{block}

  \begin{block}{OTHER}
    \Rfunction{matchLRPatterns}, \Rfunction{trimLRPatterns},
    \Rfunction{matchProbePair}, \Rfunction{findPalindromes},
    \Rfunction{findComplementedPalindromes}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Letter frequencies}
  \begin{block}{Single-letter frequencies}
{\footnotesize
<<alphabetFrequency>>=
alphabetFrequency(yeast1, baseOnly=TRUE)
@
}
  \end{block}

  \begin{block}{Multi-letter frequencies}
{\footnotesize
<<dinucleotideFrequency>>=
dinucleotideFrequency(yeast1)
head(trinucleotideFrequency(yeast1), 12)
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Basic transformations}
  \begin{block}{Standard transformations}
{\scriptsize
\begin{verbatim}
> x
  21-letter "DNAString" instance
seq: TCAACGTTGAATAGCGTACCG
> reverseComplement(x)
  21-letter "DNAString" instance
seq: CGGTACGCTATTCAACGTTGA
> translate(x)
  7-letter "AAString" instance
seq: STLNSVP
\end{verbatim}
}
  \end{block}

  \begin{block}{Bisulfite transformation}
{\scriptsize
\begin{verbatim}
> library(BSgenome.Celegans.UCSC.ce2)
> alphabetFrequency(Celegans$chrII, baseOnly=TRUE)
      A       C       G       T   other 
4878194 2769208 2762193 4869710       3 
> chrIIbis <- chartr("C", "T", Celegans$chrII)
> alphabetFrequency(chrIIbis, baseOnly=TRUE)
      A       C       G       T   other 
4878194       0 2762193 7638918       3
\end{verbatim}
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Letter consensus}
  \begin{block}{Consensus matrix}
{\footnotesize
<<consensusMatrix>>=
snippet <- subseq(head(sort(srPhiX174), 5), 1, 10)
consensusMatrix(snippet, baseOnly=TRUE)
@
}
  \end{block}

  \begin{block}{Consensus string}
{\footnotesize
<<consensusString>>=
consensusString(snippet)
consensusString(snippet, ambiguityMap = "N", threshold = 0.5)
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{String matching}
  \begin{block}{Match counting}
{\footnotesize
<<matchPDict>>=
data(phiX174Phage)
genome <- phiX174Phage[["NEB03"]]
negPhiX174 <- reverseComplement(srPhiX174)
posCounts <- countPDict(PDict(srPhiX174), genome)
negCounts <- countPDict(PDict(negPhiX174), genome)
table(posCounts, negCounts)
@
}
  \end{block}

  \begin{block}{Match locations}
{\footnotesize
<<matchPDict>>=
matchPDict(PDict(srPhiX174[posCounts > 0]), genome)
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Pairwise alignments}
  \begin{block}{Alignment scores}
{\footnotesize
<<pairwiseAlignments-1>>=
data(phiX174Phage)
posScore <- pairwiseAlignment(srPhiX174, genome,
              type = "global-local", scoreOnly = TRUE)
negScore <- pairwiseAlignment(negPhiX174, genome,
              type = "global-local", scoreOnly = TRUE)
cutoff <- max(pmin.int(posScore, negScore))
@
}
  \end{block}

  \begin{block}{Alignments}
{\footnotesize
<<matchPDict>>=
pairwiseAlignment(srPhiX174[posScore > cutoff], genome,
                  type = "global-local")
@
}
  \end{block}
\end{frame}


\section{Developer's Notes}

\begin{frame}[t]
  \frametitle{Long compressed sequence classes (\Biocpkg{IRanges})}
  \begin{block}{\Rclass{Rle}}
    \begin{itemize}
      \item Compressed atomic vectors
      \item Methods for standard \R{} \Rclass{atomic vector} functions
%      \item Fixed-width running window tools
      \item Concrete class with sub-typing at the slot level
    \end{itemize}
  \end{block}

  \begin{block}{\Rclass{CompressedList}}
    \begin{itemize}
      \item Compressed list of S4 objects
      \item Methods for standard \R{} \Rclass{list} functions
      \item Virtual class with sub-typing at the subclass level
%      \item Has sibling \Rclass{SimpleList} class
    \end{itemize}
  \end{block}

  \begin{block}{\Rclass{IRanges} (as Sequences)}
    \begin{itemize}
      \item \Rfunction{as.integer} coercion
      \item Subscripting via \Rfunction{seqselect}, \Rfunction{window}, and
        \Rfunction{[}
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{Pointer referenced sequence classes}
  \begin{block}{\Rclass{XVector} (\Biocpkg{IRanges})}
    \begin{itemize}
      \item External pointer-based atomic vectors
      \item Virtual class
      \item Concrete subclasses:
      \begin{itemize}
        \item \Rclass{XRaw} -- Underlies \Biocpkg{Biostrings} infrastructure
        \item \Rclass{XInteger} -- Experimental integer vector class
        \item \Rclass{XDouble} -- Experimental real number vector class
      \end{itemize}
    \end{itemize}
  \end{block}

  \begin{block}{\Rclass{XString} (\Biocpkg{Biostrings})}
    \begin{itemize}
      \item Virtual class
      \item Concrete subclasses:
      \begin{itemize}
        \item \Rclass{BString} -- Any ``biological" sequence
        \item \Rclass{DNAString} -- DNA sequence
        \item \Rclass{RNAString} -- RNA sequence
        \item \Rclass{AAString} -- Amino acid sequence
      \end{itemize}
    \end{itemize}
  \end{block}
\end{frame}


\section{Resources}

\begin{frame}
  \frametitle{Resources}
  \Bioconductor{} Web site
  \begin{itemize}
    \item `\Biocpkg{IRanges}', `\Biocpkg{GenomicRanges}', and
      `\Biocpkg{Biostrings}' links.
    \item \url{http://bioconductor.org}
    \item `\href{http://bioconductor.org/docs/install/}{Installation}',
      `\href{http://bioconductor.org/packages/release/Software.html}{Software}',
      and `\href{http://bioconductor.org/docs/mailList.html}{Mailing lists}'
      links.
  \end{itemize}
  Help in \R{}
  \begin{itemize}
    \item \Rcode{help.start()} to view a help browser.
    \item \Rcode{help(package = "Biostrings")}
    \item \Rcode{?findOverlaps}
    \item \Rcode{browseVignettes("GenomicRanges")}
  \end{itemize}
\end{frame}


\end{document}

%\VignetteDepends{GenomicFeatures, BSgenome, BSgenome.Scerevisiae.UCSC.sacCer2,
%                 BSgenome.Hsapiens.UCSC.hg19, SNPlocs.Hsapiens.dbSNP.20090506, hgu95av2probe}
%\VignetteIndexEntry{The GenomicFeatures and BSgenome packages}
%\VignettePackage{CSAMA10}

\documentclass{beamer}

\usepackage{BioconductorSlides}
\SweaveOpts{keep.source=TRUE}

\title{\Biocpkg{GenomicFeatures} and \Biocpkg{BSgenome}}
\author{Patrick Aboyoun}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{14-18 June, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 64)
@

\frame{\titlepage}

\section{Introduction}

\begin{frame}[t]
  \frametitle{\Bioconductor{} Sequence Packages}
\begin{figure}[ht]
 \centering
  \includegraphics[width=4in,height=3in]{packageStack}
\end{figure}
\end{frame}

\begin{frame}[t]
  \frametitle{\Bioconductor{} Sequence Annotation Packages}
  \begin{block}{\Biocpkg{GenomicFeatures}}
    \begin{itemize}
      \item Management of transcript information using
        \Biocpkg{GenomicRanges} infrastructure
      \item Transcripts stored in separate SQLite databases
    \end{itemize}
  \end{block}

  \begin{block}{\Biocpkg{BSgenome}}
    \begin{itemize}
      \item Management of whole genomes using \Biocpkg{Biostrings}
        infrastructure
      \item Tools for operating on those genomes
      \item Genomes stored in separate
        \Rpackage{BSgenome.}\textit{Organism.Provider.BuildVersion}
        packages
      \item Support for pre-build SNP packages for human
    \end{itemize}
  \end{block}
\end{frame}


\section{GenomicFeatures}

\begin{frame}[t,fragile]
  \frametitle{\Biocpkg{GenomicFeatures} transcript sources}
  \begin{block}{Constructors}
    \Rfunction{makeTranscriptDbFromBiomart},
    \Rfunction{makeTranscriptDbFromUCSC}
  \end{block}

{\footnotesize
<<loadGenomicFeatures>>=
library(GenomicFeatures)
nrow(supportedUCSCtables())
head(supportedUCSCtables(), 10)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{TranscriptDb} basics}
  \begin{block}{Making a \Rclass{TranscriptDb} object}
{\small
<<makeUCSC, eval=FALSE>>=
mm9KG <-
  makeTranscriptDbFromUCSC(genome = "mm9",
                           tablename = "knownGene")
@
}
  \end{block}
  \begin{block}{Saving and Loading}
{\small
<<saveFeatures, eval=FALSE>>=
saveFeatures(mm9KG, file="mm9KG.sqlite")
@
<<loadFeatures>>=
mm9KGChr9 <-
  loadFeatures(system.file("extdata", "mm9KGChr9.sqlite",
                           package = "CSAMA10"))
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{TranscriptDb} class}
{\small
<<TranscriptDb>>=
mm9KGChr9
@
}
\end{frame}

\begin{frame}{\Rclass{TranscriptDb} schema}
  \begin{figure}
    \includegraphics[width=4.25in]{transcriptschema.png}
  \end{figure}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Ungrouped transcript-related information}
  \begin{block}{Extractors}
    \Rfunction{transcripts}, \Rfunction{exons}, \Rfunction{cds}
  \end{block}

{\footnotesize
<<transcripts>>=
tx <- transcripts(mm9KGChr9)
length(tx)
head(tx, 5)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Grouped transcript-related information}
  \begin{block}{Extractors}
    \Rfunction{transcriptsBy}, \Rfunction{exonsBy},
    \Rfunction{cdsBy}, \Rfunction{intronsByTranscript},
    \Rfunction{fiveUTRsByTranscript},
    \Rfunction{threeUTRsByTranscript}
  \end{block}

{\footnotesize
<<exonsBy>>=
txExons <- exonsBy(mm9KGChr9)
txIntrons <- intronsByTranscript(mm9KGChr9)
txExons[6]
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Overlapping with transcripts}
  \begin{block}{Methods}
    \Rfunction{findOverlaps}, \Rfunction{countOverlaps},
    \Rfunction{match}, \Rfunction{\%in\%},
    \Rfunction{subsetByOverlaps}
  \end{block}
\vskip12pt
  \begin{block}{Usage}
{\footnotesize
<<findOverlaps-help, eval=FALSE>>=
findOverlaps(query, subject, maxgap = 0L, minoverlap = 1L,
             type = c("any", "start", "end"),
             select = c("all", "first"))
help("findOverlaps,GRanges,GRangesList-method")
@
<<countOverlaps>>=
grngs <- GRanges("chr9", gaps(ranges(txExons[[6]])), "+")
countOverlaps(grngs, tx)
rbind(countOverlaps(grngs, txExons), countOverlaps(grngs, txIntrons))
@
}
  \end{block}
\end{frame}


\section{BSgenome}

\begin{frame}[t,fragile]
  \frametitle{\Biocpkg{BSgenome} packages}

{\scriptsize
<<available.genomes>>=
library(BSgenome)
available.genomes()
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rclass{BSgenome} class decomposition}
  \begin{block}{\Rclass{BSgenome} slots}
{\scriptsize
<<BSgenome-slots>>=
getSlots("BSgenome")
@
}
  \end{block}

  \begin{block}{Notes}
    \begin{itemize}
      \item \Rfunarg{.seqs\_cache} and \Rfunarg{.link\_counts}
        slots manage memory.
      \item \Rfunarg{seqs\_dir} and \Rfunarg{masks\_dir} slots
        specify storage location.
    \end{itemize}
  \end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{\Rclass{BSgenome} methods}
  \begin{block}{Sequence selection}
    \Rfunction{[[}, \Rfunction{\$}
  \end{block}

  \begin{block}{Subsequence selection}
    \Rfunction{getSeq}
  \end{block}

  \begin{block}{Accessors}
    \Rfunction{length}, \Rfunction{names}/\Rfunction{seqnames},
    \Rfunction{mseqnames}, \Rfunction{seqlengths},
    \Rfunction{masknames}, \Rfunction{sourceUrl}
  \end{block}

  \begin{block}{Matching}
    \Rfunction{vmatchPattern}, \Rfunction{vcountPattern},
    \Rfunction{vmatchPDict}, \Rfunction{vcountPDict},    
    \Rfunction{matchPWM}, \Rfunction{countPWM}
  \end{block}

  \begin{block}{SNPs (Human only at this point)}
    \Rfunction{injectSNPs}, \Rfunction{SNPlocs\_pkgname},
    \Rfunction{SNPcount}, \Rfunction{SNPlocs}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Biocpkg{BSgenome} package without masks}

{\footnotesize
<<yeast>>=
library(BSgenome.Scerevisiae.UCSC.sacCer2)
Scerevisiae
Scerevisiae$chrI
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Biocpkg{BSgenome} package with masks}

{\footnotesize
<<human>>=
library(BSgenome.Hsapiens.UCSC.hg19)
Hsapiens$chr1
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Sequence information}

  \begin{block}{Operations that don't load sequences}
{\footnotesize
<<yeast-seqnames>>=
head(seqnames(Scerevisiae), 6)
head(seqlengths(Scerevisiae), 8)
@
}
  \end{block}

  \begin{block}{Operation that does}
{\footnotesize
<<yeast-alphabetFrequency>>=
sapply(head(seqnames(Scerevisiae), 8), function(i)
       alphabetFrequency(Scerevisiae[[i]], baseOnly=TRUE))
@
}
  \end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Matches for single pattern across genome}

{\footnotesize
<<vcountPattern>>=
exclude <- setdiff(seqnames(Hsapiens), c("chr1", "chr2"))
vcountPattern("ACYTANCAGT", Hsapiens,
              fixed = c(pattern = FALSE, subject = TRUE),
              exclude = exclude)
patmatch <-
vmatchPattern("ACYTANCAGT", Hsapiens,
              fixed = c(pattern = FALSE, subject = TRUE),
              exclude = exclude, asRangedData = FALSE)
head(patmatch, 3)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Pattern dictionary (Microarray probes)}

{\footnotesize
<<hgu95av2probe>>=
library("hgu95av2probe")
probes <- DNAStringSet(hgu95av2probe$sequence[1:100])
head(probes, 10)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Count matches for multiple patterns across genome}

{\scriptsize
<<vcountPDict>>=
counts <- vcountPDict(probes, Hsapiens, exclude = exclude)
head(counts, 5)
dim(counts)
whichMatch <- seqselect(counts$index, counts$count > 0)
length(whichMatch)
whichMatch
matchedProbes <- probes[whichMatch]
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Find match locations for probes}

{\footnotesize
<<matchPDIct>>=
matchLocs <- matchPDict(PDict(matchedProbes), Hsapiens$chr2)
extractAllMatches(Hsapiens$chr2, matchLocs)
@
}
\end{frame}


\begin{frame}[t,fragile]
  \frametitle{\Rpackage{SNP} packages}

{\footnotesize
<<available.SNPs>>=
available.SNPs()
@
<<injectSNPs>>=
SNPlocs_pkgname(Hsapiens)
HsWithSNPs <-
  injectSNPs(Hsapiens, "SNPlocs.Hsapiens.dbSNP.20090506")
class(HsWithSNPs)
SNPlocs_pkgname(HsWithSNPs)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{\Rpackage{SNP} exploration}

{\scriptsize
<<SNPexploration>>=
SNPcount(HsWithSNPs)
alphabetFrequency(Hsapiens$chr1)
alphabetFrequency(HsWithSNPs$chr1)
@
}
\end{frame}


\section{Resources}

\begin{frame}
  \frametitle{Resources}
  \Bioconductor{} Web site
  \begin{itemize}
    \item `\Biocpkg{GenomicFeatures}' and `\Biocpkg{BSgenome}' links.
    \item \url{http://bioconductor.org}
    \item `\href{http://bioconductor.org/docs/install/}{Installation}',
      `\href{http://bioconductor.org/packages/release/Software.html}{Software}',
      and `\href{http://bioconductor.org/docs/mailList.html}{Mailing lists}'
      links.
  \end{itemize}
  Help in \R{}
  \begin{itemize}
    \item \Rcode{help.start()} to view a help browser.
    \item \Rcode{help(package = "BSgenome")}
    \item \Rcode{?transcriptsBy}
    \item \Rcode{browseVignettes("GenomicFeatures")}
  \end{itemize}
\end{frame}


\end{document}

%\VignetteDepends{EatonEtAlChIPseq, chipseq}
%\VignetteIndexEntry{Lab 7: A ChIP-Seq Workflow}
%\VignetteKeywords{ChIPseq}
%\VignettePackage{CSAMA10}

\documentclass[a4paper]{article}

\usepackage{BioconductorVignette}
\newcommand{\GenomicRanges}{\Biocpkg{GenomicRanges}}
\SweaveOpts{keep.source=TRUE}

\title{Lab 7: A ChIP-Seq Workflow}
%% 'authblk' style
\author{Martin Morgan}
\author{Patrick Aboyoun}
\affil{Fred Hutchinson Cancer Research Center, Seattle, WA 98008}

\date{14-18 June, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 60)
olocale=Sys.setlocale(locale="C")
@ 

\maketitle

\section{Introduction}

These exercises focus on a ChIP-seq work flow described in a vignette
in the \Biocpkg{GenomicRanges} package.

<<initialize, results=hide>>=
library("GenomicRanges")
@ 

We use a subset of the ChIP-seq data for origin recognition complex
(ORC) binding sites in \textit{Saccharomyces cerevisiae} from the
paper \textit{Conserved nucleosome positioning defines replication
  origins}, Eaton et~al. (PMID
\href{http://genesdev.cshlp.org/content/24/8/748.abstract}{20351051}). The
subset consists of all the MAQ alignments to chromosome XIV for two
replicates of ORC ChIP-seq data. The subset is contained in the
\Rpackage{EatonEtAlChIPseq} package, and we will use a helper function
available in the \Rpackage{CSAMA10} package

<<EatonEtAlChIPseq>>=
library("EatonEtAlChIPseq")
library("CSAMA10")
@ 


\section{Input and Quality Assessment}

We start with looking at the alignments, which were created using MAQ
(Li et al. 2008) with a maximum mismatch of 3 bases and a minimum
Phred quality score of 35.  The data contained in the
\Rpackage{EatonEtAlChIPseq} package were obtained and extracted from
\href{ftp://ftp.ncbi.nih.gov/pub/geo/DATA/supplementary/samples/GSM424nnn/GSM424494/}{GEO
  files} GSM424494\_wt\_G2\_orc\_chip\_rep1.mapview.txt.gz and
GSM424494\_wt\_G2\_orc\_chip\_rep2.mapview.txt.gz.

<<AlignedReadFiles>>=
extdataDir <- system.file("extdata", package="EatonEtAlChIPseq")
fls <- list.files(extdataDir, ".*gz$", full=TRUE)
basename(fls)
@ 

\subsection{Input}

These files can be read in using \Rfunction{readAligned} from the
\Biocpkg{ShortRead} package, with \Rfunarg{type="MAQMapview"}. Here
we read in the first replicate.

<<readAligned>>=
orcAlignsRep1 <- readAligned(fls[[1]], type = "MAQMapview")
orcAlignsRep1
@ 

A necessary step is to ensure that the \Rcode{chromosome} naming of
\Robject{orcAlignsRep1} is consistent with the conventions used in 
steps down-stream;
here we want to change \Rcode{S288C\_14} to \Rcode{chrXIV}. Using the 
tools for that from the \Biocpkg{ShortRead} package, we do this as follows.

<<ChromosomeRecode>>=
chromosome <- chromosome(orcAlignsRep1)
levels(chromosome) <- "chrXIV"
orcAlignsRep1 <- renew(orcAlignsRep1, chromosome=chromosome)
@ 

Similar actions can be used to read in and recode the second
replicate. % FIXME: 'can be' or 'need to be'?

A second correction is also required, reflecting an idiosyncrasy in
data handling. \Biocpkg{ShortRead} expects all DNA sequence and
quality scores to read 5' to 3' from left to right.  On the other
hand, in \Robject{orcAlignsRep1}, reads on the minus strand are
represented by their reverse complement, as they would appear when
aligned to the reference sequence. The utility function
\Rfunction{renewEatonEtAl}, from the \Rpackage{CSAMA10} package will
do the necessary adjustment for us.  It reads on the minus strand to
conform to \Biocpkg{ShortRead} expectations. Here is its code:

<<Renew>>=
renewEatonEtAl
@ 

This step is not normally required.

\subsection{Quality Assessment}

As an exercise, run the \Rfunction{qa} and \Rfunction{report}
functions from the \Biocpkg{ShortRead} package on the two
replicates. A wrinkle is that the reads of the Eaton et al.\ dataset 
are represented in an older
file format (MAQMapview) that is not supported by \Rfunction{qa};
so, here we perform the quality assessment on the aligned reads only,
giving the \Rfunction{qa} a list of \Rclass{AlignedRead}
objects.

<<QualityAssessment, eval=FALSE>>=
data(orcAlignsRep2)
qa <- qa(list(rep1=renewEatonEtAl(orcAlignsRep1),
              rep2=renewEatonEtAl(orcAlignsRep2)))
rpt <- report(qa)
browseURL(rpt)
@ 

Some caution in interpretation of results is required, as the reads
have already been processed to some extent (e.g., low quality reads
removed). Nonetheless, there are several unusual features of the
reads. Discuss these with your neighbors.

\section{Pre-Processing: Filtering Peaks}

For illustration purposes we will focus on the first replicate.

<<EatonEtAlReplicateOne>>=
orcAlignsRep1
@

In this subsection we will demonstrate how to perform three filtering
operations on alignments produced by the MAQ software through the
following restrictions:

\begin{itemize}
\item Number of mismatches in alignment must be $\le$ 3 (guideline
  specified in paper)
\item No duplicates of \{chromosome, strand, position\} combinations
  (PCR bias correction)
\item An alignment on one strand must have a plausible alignment on
  the complementary strand (``symmetry"  restriction)
\end{itemize} 
%% 
The first two restrictions can be implemented using functionality from
the \Biocpkg{ShortRead} package, while the last one can be performed
using operations within the \Biocpkg{GenomicRanges} package.  Filters
similar to these are implemented in many peak calling algorithms.

In the previous section we loaded the \Robject{orcAlignsRep1} object,
an instance of the \Biocpkg{ShortRead} class \Rclass{AlignedRead}.
This object contains information on the characteristics of the read as
well as its alignment to a reference genome, including information on
the number of mismatches for the best alignment. Using functionality from
the \Biocpkg{ShortRead} package we can perform the first two filtering
operations, which result in a subset that is roughly 18\% of the size of
the original MAQ alignment file.

<<EatonAlignmentFiltering-1>>=
subsetRep1 <-
  orcAlignsRep1[alignData(orcAlignsRep1)[["nMismatchBestHit"]] <= 3]
length(subsetRep1) / length(orcAlignsRep1)
subsetRep1 <- subsetRep1[occurrenceFilter(withSread=FALSE)(subsetRep1)]
length(subsetRep1) / length(orcAlignsRep1)
subsetRep1
@

The last filtering criterion, a ``symmetry" filter, requires
an understanding of the interval spans for the alignments rather than
just the ``leftmost" alignment location, i.\,e.\ start location on the
positive strand or end location on the negative strand, represented in
the \Rclass{AlignedRead} class. As such we will coerce the alignment
subset contained in \Robject{subsetRep1} to a \Rclass{GRanges} object
using a \Rmethod{coerce} method from the \Biocpkg{ShortRead} package.

<<EatonOrcRanges>>=
rangesRep1 <- as(subsetRep1, "GRanges")
head(rangesRep1, 3)
@

\Rclass{AlignedRead} objects lack information on chromosome length,
so we will add it to the new \Robject{rangesRep1} object.

<<EatonAddSeqlengths>>=
seqlengths(rangesRep1) <- 784333
@

For our ``pseudo" paired-read filter, we will use the authors' estimate
of the mean fragment length (around 150 base pairs). In particular, we
will construct a filter where each alignment on the plus strand must have
a corresponding alignment somewhere within [100, 200] bp downstream on the
minus strand and vice versa with those alignments on the minus strand.

This filtering process can be achieved through an interval overlap
operation between the starts of the alignments on the minus strand
and the projected end of the alignments on the plus strand, where
the former can be derived by the code

<<EatonNegStarts>>=
negRangesRep1 <- rangesRep1[strand(rangesRep1) == "-"]
negStartsRep1 <- resize(negRangesRep1, 1)
@

\noindent
and the latter by the code

<<EatonPossibleEnds>>=
posRangesRep1 <- rangesRep1[strand(rangesRep1) == "+"]
posEndsRep1 <- shift(posRangesRep1, 99)
posEndsRep1 <- resize(posEndsRep1, 100)
strand(posEndsRep1) <- "-"
@

The results of the interval overlap are shown below. This filter
flagged roughly 4.5\% of the remaining alignments for removal,
resulting in keeping 17.3\% of the original set of alignments when
including the results of the first two filtering steps.
% FIXME shouldn't these numbers be computed on the fly (\Sexpr).

<<EatonMatchingPairs>>=
strandMatching <- findOverlaps(negStartsRep1, posEndsRep1)
posKeep <- unique(subjectHits(strandMatching))
negKeep <- unique(queryHits(strandMatching))
length(posKeep) / length(posEndsRep1)
length(negKeep) / length(negStartsRep1)
(length(posKeep) + length(negKeep)) / length(orcAlignsRep1)
@

<<EatonAlignmentFiltering-2>>=
posFilteredRangesRep1 <- posRangesRep1[posKeep]
negFilteredRangesRep1 <- negRangesRep1[negKeep]
@

\section{Finding peaks}

Once the alignments have been filtered, they can be aggregated into
coverage vectors. Many peak calling algorithms use a point estimate
for the average fragment size of each read. We suppose that the size
of the reads are uniformly distributed over [100, 200] base pairs,
although more elaborate distributions are readily modeled. We
implement our model by weighting the coverage vector of the original
reads with a function that gives full weight to positions 100~bp
upstream, and then linearly decreasing weights for the next 100
bp. For the \Rfunction{runwtsum} function from \Biocpkg{IRanges},
these weights for the positive and negative strands are expressed by
the vectors:

<<CoverageWeights, fig=TRUE, include=FALSE, eps=FALSE, height=3>>=
posWeights <- c(seq(0.01, 1, length = 100), rep(c(1, 0), c(101, 200)))
negWeights <- rev(posWeights)
plot(-200:200, posWeights, xlab = "Relative Position",
     ylab = "Coverage Weight", type = "l")
lines(-200:200, negWeights, lty=2, col="blue")
@

\begin{figure}[tb]
  \begin{center}
     \includegraphics[width=\textwidth]{Lab-7-ChIPSeq-CoverageWeights}  
     \caption{\label{fig-CoverageWeights}%
      Coverage weights for positive strand weighted sums.}
  \end{center}
\end{figure}

The first step in constructing this coverage vector is to tabulate the
alignments by their start positions on both the positive and negative
strand. This is done with the \Rfunction{resize} function, whose
second argument is the width (in this case, 1) of the resulting
fragment. We will use the \Rfunction{coverage} function on these start
values, which will produce \Rclass{RleList} representations of the
coverage vectors.

<<EatonStartCoverage>>=
posStartsCoverRep1 <- coverage(resize(posFilteredRangesRep1, 1))
negStartsCoverRep1 <- coverage(resize(negFilteredRangesRep1, 1))
@
%% 
The second step in the process is aggregating upstream alignments
using the \Robject{posWeights} and \Robject{negWeights} objects
defined above.

<<EatonExtendedCoverage>>=
posExtCoverRep1 <-
  round(runwtsum(posStartsCoverRep1, k = 401, wt = posWeights,
                 endrule = "constant"))
negExtCoverRep1 <-
  round(runwtsum(negStartsCoverRep1, k = 401, wt = negWeights,
                 endrule = "constant"))
@

Before we proceeded any further, we will define two plot functions
for visualizing coverage vectors: \Rfunction{plotCoverage} for
displaying a single coverage vector and
\Rfunction{plotStrandedCoverage} for displaying back-to-back
coverage vectors for dual-stranded data.

<<plotCoverage>>=
plotCoverage <-
function(x, xlab = "Position", ylab = "Coverage",...)
{
    plot(c(start(x), length(x)), c(runValue(x), tail(runValue(x), 1)),
         type = "s", col = "blue", xlab = xlab, ylab = ylab, ...)
}
plotStrandedCoverage <-
function(positive, negative, xlab = "Position", ylab = "Coverage",...)
{
    ylim <- min(max(positive), max(negative)) * c(-1, 1)
    plotCoverage(positive, ylim = ylim, ...)
    lines(c(start(negative), length(negative)),
          - c(runValue(negative), tail(runValue(negative), 1)),
          type = "s", col = "red")
    abline(h = 0, col = "dimgray")
}
@

The coverage across chromosome XIV of the filtered alignments is
shown in Figure \ref{fig-EatonPlotStrands}. In general this plot
shows a near mirror image of coverage vectors between the positive
and negative strand.

<<EatonPlotStrands, fig=TRUE, include=FALSE, eps=FALSE, height=5>>=
plotStrandedCoverage(posExtCoverRep1[[1]], negExtCoverRep1[[1]])
@

\begin{figure}[tb]
  \begin{center}
     \includegraphics[width=\textwidth]{Lab-7-ChIPSeq-EatonPlotStrands}  
     \caption{\label{fig-EatonPlotStrands}%
      Plot of coverage across chromosome XIV.}
  \end{center}
\end{figure}

To reduce these measures to a single dimension, we will be
conservative and choose the smallest value between the positive and
negative strand coverage vectors using the \Rfunction{pmin} method for
\Rclass{RleList} objects. 

The experimental design of Eaton et al.~does not include a `control'
lane; such lanes are commonly included in transcription factor and
other ChIP-seq experiments. Many software packages implement more
elaborate approaches to modeling peaks, for example the PeakSeq, MACS,
SBP, \Biocpkg{BayesPeak}, and SWEMBL packages; this software is
primarily useful for transcription factor style, but not nucleosome,
analysis.  A review of alternatives is available.
%% FIXME: citation

<<EatonExtendedCoverage>>=
combExtCoverRep1 <- pmin(posExtCoverRep1, negExtCoverRep1)
quantile(combExtCoverRep1, c(0.5, 0.9, 0.95))
@

We now can call peaks off the combined coverage object
\Robject{combExtCoverRep1}. Since the median height for the
combined coverage on chromosome XIV is 4, we can limit our
attention to areas on the chromosome with coverage $\ge 5$
using the \Rfunction{slice} function. From there we can
derive a heuristic for a meaningful peaks as those achieving
a maximum height $\ge 28$, which selects 22 peaks.

<<EatonPeaks>>=
peaksRep1 <- slice(combExtCoverRep1, lower = 5)
peakMaxsRep1 <- viewMaxs(peaksRep1)
tail(sort(peakMaxsRep1[[1]]), 30)
peaksRep1 <- peaksRep1[peakMaxsRep1 >= 28]
peakRangesRep1 <-
  GRanges("chrXIV", as(peaksRep1[[1]], "IRanges"),
          seqlengths = seqlengths(rangesRep1))
length(peakRangesRep1)
@

We can now compare the significant peaks we selected with
those selected by the authors. Using interval comparison
tools, we see there is general agreement between our peaks
and those of the authors.

<<EatonExtendedReads>>=
data(orcPeaksRep1)
countOverlaps(orcPeaksRep1, peakRangesRep1)
countOverlaps(peakRangesRep1, orcPeaksRep1)
@

Eaton et al.~continue their analysis in a number of interesting
directions (e.g., motif characterization, nucleosome positioning), and
it is left as an open exercise to explore \R{} / \Bioconductor{}
solutions to these problems.

\section{Analysis of designed experiments}

The approach outlined above does not make use of the second
experimental replicate of Eaton et al., and in general analysis of
designed experiments is still relatively unexplored -- studies to date
often include technical replicates, but use this data by pooling
across replicates (lanes) prior to peak calling. Packages such as
\Biocpkg{DESeq} may be appropriate for analysis of designed
experiments once peaks have been identified. This approach is likely
to be appropriate when the assay targets clearly separated or
previously identified binding sites; it would not be appropriate when
the assay targets broad or poorly defined peaks. This represents an
interesting area for further development.

%% \section{Annotation}

%% FIXME: Annotation -- gene region, count nucleosome regions, normalized
%% by gene length -- transcription start sites. Next step stratify
%% expression values

\end{document}

%\VignetteDepends{}
%\VignetteIndexEntry{Rsamtools and Work Flows with Larger Data}
%\VignettePackage{EMBL2010}

\documentclass{beamer}

\usepackage{BioconductorSlides}
\AtBeginSection[]
{
  \begin{frame}<beamer>{Outline}
    \tableofcontents
  \end{frame}
}

\usepackage[authoryear,round]{natbib}
\bibliographystyle{plainnat}
\SweaveOpts{keep.source=TRUE}

\title{\Biocpkg{Rsamtools} and Work Flows with Larger Data}
\author{Martin Morgan} \institute[FHCRC]{Fred Hutchinson Cancer
  Research Center} \date{14-18 June, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 40)
@ 

\frame{\titlepage}

\begin{frame}
  A time line
  \begin{itemize}
  \item Yesterday: generating and aligning sequences; wrestling with
    large data; establishing common work flows (e.g., ChIP-seq).
  \item Today: revising common work flows; coming to terms with data
    volume (e.g., multiplexing); analyzing designed experiments.
  \item Tomorrow: 100,000 genomes (George Church, New York Times, 7
    June 2010)
  \end{itemize}
  Themes
  \begin{itemize}
  \item Increasing confidence with early stages of the pipeline --
    reads, their qualities, and alignments \emph{per se} become less
    important.
  \item Increasing emphasis on experimental design.
  \item Increasing use of collections of whole genomes, e.g., as data
    bases to query against.
  \end{itemize}
\end{frame}

\section{Yesterday}

\subsection{Review: Work Flow}

\begin{frame}{Work flow}
  Prior to analysis
  \begin{itemize}
  \item Biological preparation, e.g., ChIP.
  \item `Sequencing': library preparation, cluster generation,
    imaging, \ldots
  \end{itemize}
  Analysis
  \begin{enumerate}
  \item Pre-processing, quality assessment, exploratory analysis
  \item Domain-specific analysis ( ChIP-seq, Digital gene expression,
    RNA-seq, Microbial / community structure, \ldots)
  \item Annotation \& integration
  \end{enumerate}\
\end{frame}

\begin{frame}[fragile]{\Biocpkg{ShortRead} data input}
<<library, results=hide>>=
library(EatonEtAlChIPseq)
fl <- system.file("extdata", 
  "GSM424494_wt_G2_orc_chip_rep1_S288C_14.mapview.txt.gz",
  package="EatonEtAlChIPseq") 
aln <- readAligned(fl, type = "MAQMapview")
@ 
\end{frame}

\begin{frame}[fragile]{Alphabet by cycle}
  Expectation: nucleotide use independent of cycle
<<abc>>=
alnp <- aln[strand(aln) == "+"]
abc <- alphabetByCycle(sread(alnp))
class(abc)
abc[1:6,1:4]
@ 
\end{frame}

\begin{frame}[fragile]{Alphabet by cycle}
  \begin{columns}
    \column{.5\textwidth} 
    \Rfunction{matplot} takes a matrix and plots each column as a set
    of points
<<abc-plot,fig=TRUE,include=FALSE,prefix=FALSE>>=
tabc <- t(abc[1:4,])
matplot(tabc, type="l",
        lty=1, lwd=3)
@ 
    \column{.5\textwidth}
    \includegraphics[width=\textwidth,height=!]{abc-plot.pdf}
  \end{columns}
\end{frame}

\subsection{Annotation}

\begin{frame}{Annotation}
  \begin{itemize}
  \item Gene- (and chip-) centric
  \item Pathways (KEGG, GO)
  \item Community resources (e.g., BioMarts, UCSC)
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{\Biocpkg{AnnotationDbi}}
  \begin{itemize}
  \item \R{} packages with versioned data.
  \item Pre-built \Rpackage{org.*.db}, \Biocpkg{GO.db},
    \Biocpkg{KEGG.db} and custom-built.
  \end{itemize}  
  Example: starts / ends of yeast features, from SGD
<<AnnotationDbi, eval=FALSE, results=hide>>=
library(org.Sc.sgd.db)
ls('package:org.Sc.sgd.db') # Discovery
start <- toTable(org.Sc.sgdCHRLOC)
end <- toTable(org.Sc.sgdCHRLOCEND)
tbl <- merge(start, end)
@
\end{frame}

\begin{frame}[fragile]{\Biocpkg{biomaRt}}
  \begin{itemize}
  \item Web accessible annotations; from ENSEMBL
  \item Discovery: \Rfunction{listMarts}, \Rfunction{listDatasets}.
  \item Use: \Rfunction{useMart}.
  \end{itemize}
<<biomart1, eval=FALSE, results=hide>>=
library(biomaRt)
listMarts()
mart <- useMart("ensembl")
listDatasets(mart)
ens <- useMart("ensembl", 
               dataset="scerevisiae_gene_ensembl")
@
\end{frame}

\begin{frame}[fragile]{Extracting data with \Biocpkg{biomaRt}}
  \begin{itemize}
  \item Apply \emph{filters} (\Rfunction{listFilters}) and
    \emph{attributes} (\Rfunction{listAttributes})
  \end{itemize}
<<biomart2, eval=FALSE, results=hide>>=
head(listFilters(ens))
head(listAttributes(ens))
## example query
getBM(attributes=
        c("ensembl_gene_id","chromosome_name",
          "strand", "start_position", "end_position"), 
      filters="entrezgene",
      values=c(1466398,1466399,1466400), mart=ens)
@
\end{frame}

\begin{frame}[fragile]{\Biocpkg{rtracklayer}}
  Import UCSC Genome Browser data into \R{}
  \begin{itemize}
    \item Create a session: \Rfunction{browserSession}.
    \item List available genomes from UCSC: \Rfunction{ucscGenomes}.
    \item Set up a genome object: \Rfunction{genome}.
    \item List available tracks: \Rfunction{trackNames}.
  \end{itemize}
<<rtracklayer, eval=FALSE, results=hide>>=
library(rtracklayer)
session <- browserSession()
head(ucscGenomes())
genome(session) <- "hg19"
head(trackNames(session))
@
\end{frame}

\begin{frame}[fragile]{Managing tracks with \Biocpkg{rtracklayer}}
  \begin{itemize}
    \item Generate a query for UCSC: \Rfunction{ucscTableQuery}.
    \item Retrieve a UCSC track: \Rfunction{getTable}.
  \end{itemize}
<<rtracklayer2, results=hide, eval=FALSE>>=
## generate a query
query <- ucscTableQuery(session, "refGene")
## get the data
track <- getTable(query)
@

\begin{itemize}
\item Also possible to push tracks to UCSC
\end{itemize}
\end{frame}

\begin{frame}[fragile]{Demo}
<<seq2anno, eval=FALSE>>=
system.file('script', 'seq2anno.R', package='CSAMA10')
@ 
\end{frame}

\section{Today}

\begin{frame}{Today}
  Limitations to the \Rclass{AlignedRead} class and
  \Biocpkg{ShortRead} work flow
  \begin{itemize}
  \item Hard to input an arbitrary subset of reads
  \item Sequence, quality, identifier and other information included,
    but not always necessary
  \item Reads must be aligned without indels or gaps
  \end{itemize}
\end{frame}

\subsection{Rsamtools}

\begin{frame}{\software{samtools} and \Biocpkg{Rsamtools}}
  \href{http://samtools.sourceforge.net/}{\software{samtools}}
  \begin{itemize}
  \item Data format -- text (SAM) and binary (BAM)
  \item Tools to manipulate (e.g., merge), analyze (e.g., pileup) and
    view
  \item Bindings for other languages, e.g.,
    \href{http://picard.sourceforge.net/index.shtml}{Picard}
  \end{itemize}
  \Biocpkg{Rsamtools}
  \begin{itemize}
  \item Input and represent BAM files.
  \item High-level: \Rfunction{readAligned}; with
    \Rfunarg{type="BAM"}; \Rfunction{readPileup}
  \item Flexible: \Rfunction{scanBam}
  \item Experiment-wide: \Rfunction{BamViews}
  \end{itemize}
\end{frame}

\begin{frame}{Input}
  \Rclass{ScanBamParam}
  \begin{description}
  \item[which] \Rclass{GRanges} selecting reference, genome
    coordinates, strand.
  \item[flag] select paired / mapped / mate mapped reads
  \item[what] fields to retrieve, e.g., query name, reference name,
    strand, position, width, cigar
  \end{description}
  Remote access
  \begin{itemize}
  \item E.g., 1000 genomes individual NA19240, chromosome 6, 'Solexa'
    reads, aligned with MAQ available via
    \href{ftp://ftp-trace.ncbi.nih.gov/1000genomes/ftp/pilot_data/data/NA19240/alignment/NA19240.chrom6.SLX.maq.SRP000032.2009_07.bam}{ftp}
  \end{itemize}
\end{frame}

\subsection{Gapped alignments}
\begin{frame}{Gapped alignments}
  The \Rclass{GappedAlignments} class in \Biocpkg{GenomicRanges} 
  \begin{itemize}
  \item \Rfunction{readGappedAlignments} uses \Rfunction{scanBam}
  \item Genomic coordinates, `cigar', covered intervals
  \item Cigar: run length encoding; M (match), I, D (insertion,
    deletion), N (skipped), S, H (soft, hard clip), P (padding). E.g.,
    \texttt{35M}, \texttt{18M2I15M}
  \item Accessors, subsetting, narrowing, \Rfunction{pintersect},
    \Rfunction{coverage}, \ldots
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Example}
<<scanBam-2, eval=FALSE>>=
## reads on chr 6 overlapping 100000-110000
which <- GRange("6", IRanges(100000, 110000))
param <- ScanBamParam(which=which)
## na19240url <- ftp://ftp-trace.ncbi.nih.gov/1000ge...
na19240bam <- scanBam(na19240url, param=param)
@ 
\begin{itemize}
\item Index file downloaded, or locally referenced
\item \Rfunction{scanBam} returns a nested list
  \begin{itemize}
  \item One element for each row of \Rfunction{GRanges}
  \item Nested elements correspond to \Rfunarg{what}
  \end{itemize}
\end{itemize}
\end{frame}  

\begin{frame}[fragile]{Demo}
<<seq2anno, eval=FALSE>>=
system.file('script', 'streamBam.R', package='CSAMA10')
@ 
\end{frame}

\section{Tomorrow}

\subsection{Genome Collections}
\begin{frame}[fragile]{\Rclass{BamViews}}
  \begin{itemize}
  \item Overall experiment represented by `regions of interest' (rows)
    in several samples (columns).
  \item Represent this as a `view' on which coordinated operations can
    be performed.
  \item Extended examples: \Biocpkg{Rsamtools} vignette,
    \Biocdatapkg{leeBamViews}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Demo}
<<seq2anno, eval=FALSE>>=
system.file('script', 'BamViews.R', package='CSAMA10')
@ 
\end{frame}

\section{Resources}

\begin{frame}{Resources}
  Packages
  \begin{itemize}
  \item \Biocpkg{Rsamtools}, \Biocpkg{GenomicRanges}
  \item \Biocpkg{leeBamViews}
  \end{itemize}
\end{frame}

\end{document}

%\VignetteDepends{}
%\VignetteIndexEntry{Lab 3: Reading and Manipulating Short Reads}
%\VignettePackage{CSAMA10}

\documentclass[a4paper]{article}

\usepackage{BioconductorVignette}
\newcommand\ELAND{\software{ELAND}}
\newcommand\MAQ{\software{MAQ}}
\newcommand\bam{\software{BAM}}
\newcommand\Bowtie{\software{Bowtie}}

\SweaveOpts{keep.source=TRUE, eps=FALSE, include=FALSE}

\title{Lab 3: Reading and Manipulating Short Reads}
\author{Martin Morgan\footnote{Fred Hutchinson Cancer Research Center, Seattle, WA 98008}}
\date{14-18 June, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 60)
olocale=Sys.setlocale(locale="C")
@ 

\maketitle

\tableofcontents

\section{Introduction}

This practical uses the \Biocpkg{ShortRead} package to input aligned
and other short read data files, and illustrates some of the available
sequence manipulation and quality assessment tools.  Activities during
the lab are posed as exercises. So, as a first exercise:
\begin{Exercise}
  Start an \R{} session, and load the \Biocpkg{ShortRead}
  package. 
<<ShortReadVersion>>=
library(ShortRead)
packageDescription("ShortRead")$Version
@ 
%% 
  Confirm that the version of your package is at least as recent as
  the version in this document. Seek assistance from one of the
  course assistants if you need help getting the current version of
  \Biocpkg{ShortRead}.
\end{Exercise}
%% 
The course also requires access to sample data. 
\begin{Exercise}
  Obtain and load the \Rpackage{CSAMA10} package. Use
<<csama10, eval=FALSE>>=
install.packages("path/to/CSAMA10.tar.gz", repos=NULL)
@ 
\end{Exercise}

\section{Aligned read input}

This section illustrates input of aligned reads. It focuses on aligned
reads produced by the Solexa Genome Analyzer \ELAND{} software;
reading data produced by software such as \MAQ{} or \Bowtie{}, or in
\bam{} format is described in the \Biocpkg{ShortRead} `Overview'
vignette and on the \Rfunction{readAligned} help page.

\subsection{Navigating Solexa output}

Vendor and third-party software is likely to process raw images, base
calling (\Biocpkg{Rolexa} is a \Bioconductor{} package providing
alternative base calling), and alignment to a reference genome (see
\Biocpkg{BSgenome} and the \Rfunction{matchPDict} function of
\Biocpkg{Biostrings}). \Bioconductor{} packages might enter a typical
work flow after alignment. The following starts with reads aligned
with \ELAND{}, an alignment program from the Illumina Genome Analyzer
II (GAII) platform.

We'll start by creating a variable, \Rcode{extdataDir}, containing the
directory holding the sample GAII data, and check to make sure that we
have defined the right path.
<<extdataDir>>=
extdataDir <- 
    system.file("extdata", "slx", package="CSAMA10")
file.exists(extdataDir)
stopifnot(file.exists(extdataDir))
@ 

A key functionality provided by \Biocpkg{ShortRead} is input of a
diversity of file types, both of files from the Illumina pipeline and
from other software and in formats appropriate for other
technologies. The interface to these input functions is meant to
facilitate reading one or more files into a single object. The
interface is like that for \Rfunction{list.files}: provide a directory
path where relevant files are to be found, plus a regular expression
to select the files you are interested in.
\begin{Exercise}
  Use \Rfunction{list.files} to display all files in the
  \Rcode{extdataDir} directory.
<<filePattern>>=
list.files(extdataDir)
@ 
\end{Exercise}
We'll select just one file to use in this analysis, based on files
matching the regular expression \texttt{.*\_export\_head.txt}. These
files are produced using \ELAND{} software run in
\texttt{eland-extended} mode. This mode produces files, one for each
lane (and `end' of paired end reads) that summarize diverse features
of \emph{all} reads, and is a very convenient starting point for
analysis; other inputs (e.g., \MAQ, \Bowtie, \software{BWA}, or \bam{}
files) are also supported.
\begin{Exercise}
  We'll use an abbreviated file for most parts of this lab. The
  abbreviated file contains the first 500,000 reads from a single lane
  of an Illumina paired-end run. It is from lane 1, and we will use the
  first end only. The name of the file is
  \texttt{s\_1\_1\_export\_head.txt}.  We will use this as the `pattern'
  to match, and check that we have specified the pattern appropriately
<<pattern>>=
pattern <- "s_1_1_export_head.txt"
list.files(extdataDir, pattern)
@ 
%%
  Our success shouldn't be too surprising in this case, but it often
  pays to check. For instance, the pattern above would also match a file
  with the same name but with \texttt{.tar.gz} appended!
\end{Exercise}

\subsection{\Rfunction{readAligned} and the \Rclass{AlignedRead}
  class}

The \Rfunction{readAligned} function can be used to input aligned
reads. The first argument is a directory path where alignment files
are to be found. The second argument is the regular expression to
select files to be read. An optional third argument allows the user to
specify which type of file is to be read in.
\begin{Exercise}
  Use \Rfunction{readAligned} to read in our abbreviated version of
  lane 1, specifying \texttt{SolexaExport} as the type of file.
<<readAligned>>=
aln <- readAligned(extdataDir, pattern, "SolexaExport")
@ 
%%
  See the help page for \Rfunction{readAligned} for additional
  details about supported file types.
\end{Exercise}

What does \Rfunction{readAligned} input? It inputs the short read
sequences and base call qualities, and the chromosome, position, and
strand information associated with short read alignments. This
information is expected to be provided by all short read alignemnt
software.
\begin{Exercise}
  Display the object we have read in.
<<aln>>=
aln
@ 
%
  There are \Sexpr{length(aln)} reads in the object, each read
  consisting of \Sexpr{width(aln)} nucleotides. View the first several
  reads and query information about, e.g., the number of reads that
  align to each strand, or the number of positions recorded as \Rcode{NA}.
<<aln-head>>=
head(sread(aln))
table(strand(aln), useNA="ifany")
sum(is.na(position(aln)))
@ 
%%
  Notice how elements of the \Robject{aln} object are extracted using
  \emph{accessors} such as \Rfunction{sread} and \Rfunction{strand};
  these are described on the help page for the class of the
  \Robject{aln} object (indicated in the display of \Robject{aln},
  above, as class \Rclass{AlignedRead}); note that the help page
  refers to the help page for \Rfunction{accessors} to enumerate
  additional ways of accessing the data.
\end{Exercise}
What are all the \Rcode{NA} values returned by \Rfunction{strand} and
\Rfunction{position}? These correspond to reads that did not align to
the reference genome used by \ELAND{}; that about 1/2 the reads do not
align is below normal, making this an interesting opportunity for
quality assessment. The \Rfunction{strand} function returns a factor
with three levels. The first two describe reads aligned to the plus
and minus strands, the third (\Rcode{*}) is available for successful
alignments where strand information is irrelevant.

Aligned reads contain several different kinds of information about
`quality'. Individual bases are assessed for quality during base
calling. These `raw' base qualities are `calibrated' during \ELAND{}
alignment; details of calibration are to be found in Illumina
documentation. The alignments themselves also have qualities
associated with them, with the details of alignment quality differing
between alignment algorithms. 
\begin{Exercise}
  Retrieve calibrated base quality from \Robject{aln}. 
<<quality>>=
head(quality(aln))
@ 
% 
  These qualities are string-encoded $-10 \log_{10}$
  probabilities. The encoding in this case follows a convention
  established by Illumina. The details of the encoding can be obtained
  by querying \Rcode{quality(aln)} for its \Rfunction{alphabet}; the
  letter \Rcode{A} corresponds to a $-10 log_{10}$ score of 1. 

  Numeric values are readily retrieved as a matrix, with rows
  corresponding to reads and columns to cycles.  Computations can then
  be performed on them, e.g., to determine average calibrated quality
  scores as a function of cycle.
<<quality-scores>>=
alf <- alphabet(quality(aln))
m <- as(quality(aln), "matrix")
colMeans(m)
@ 
\end{Exercise}
 
Alignment qualities are accessible with \Rfunction{alignQuality}. This
returns an object that can contain quality scores in different
formats; to extract the actual quality scores, use
\Rfunction{quality}. Reads failing to align or to align in multiple
locations have an alignment quality of 0.
\begin{Exercise}
  Retrieve the alignment quality scores, determine how many align
  poorly, and visualize the distribution (Figure~\ref{fig:alignqual})
  of scores.
<<alignQuality,fig=TRUE,height=5>>=
alignQuality(aln)
q <- quality(alignQuality(aln))
sum(q==0)
print(densityplot(q[q>1], plot.points=FALSE, 
                  xlab="Alignment quality"))
@ 
% 
\begin{figure}
  \centering
  \includegraphics[width=.8\textwidth]{Lab-3-ShortRead-alignQuality}
  \caption{Alignment quality}
  \label{fig:alignqual}
\end{figure}
\end{Exercise}

Alignment algorithms produce information in addition to basic data
about chromosome, position, and strand alignment. The exact content
varies between algorithms, and is available with
\Rfunction{alignData}. \Rfunction{alignData} returns an
\Rclass{AlignedDataFrame} object that contains these data and a
metadata description of them. For instance, \ELAND{} includes
information about whether the read passed a base-calling filter (based
on strength and consistency of early bases in the read), in addition
to the lane, tile, x and y coordinate of each read.
\begin{Exercise}
  Use the \Rfunction{alignData} function to extract the additional
  information in the \ELAND{} alignment file. The underlying data in
  this object can be accessed as though it were a data frame, for
  instance to tally the number of reads passing Illumina base calling
  filter.
<<alignData>>=
alignData(aln)
table(alignData(aln)$filtering)
@ 
\end{Exercise}

\subsection{Subsets and filters}

A very common operation is to reduce the number of reads used for
subsequent analysis. This can be done in a coordinated fashion by
creating a subset of \Robject{aln}.
\begin{Exercise}
  Select just the aligned reads passing Illumina filtering, and aligning
  to the reference genome.
<<select>>=
filtIdx <- alignData(aln)$filtering=="Y"
alignedIdx <- !is.na(strand(aln))
aln[filtIdx & alignedIdx]
@ 
\end{Exercise}
A different approach to subsetting is to use objects of class
\Rclass{SRFilter}. These can be particularly useful as an argument to
\Rfunction{readAligned}, in addition to use in interactive sessions.
\begin{Exercise}
  Construct instances of built-in filters to select reads passing the
  Illumina filtering criterion, and uniquely aligning to a fully
  assembled chromosomes. These can be `composed' into a single overall
  filter, and applied to restrict available reads.
<<filter>>=
filt1 <- alignDataFilter(expression(filtering=="Y"))
filt2 <- chromosomeFilter("chr[0-9XYM]+.fa")
filt <- compose(filt1, filt2)
caln <- aln[filt(aln)]
caln
@ 
% 
\end{Exercise}
The filters developed above could be used to filter reads while being
read in to \R, e.g,. with
<<readAliged-filter,eval=FALSE>>=
readAligned(extdataDir, pattern, type="SolexaExport", filter=filt)
@ 
% 

The \Rfunction{srFilter} function can be used to create custom
filters. The idea is that filter functions accept a single argument
\Rfunarg{x} that is an object to be filtered, and returns a logical
vector that can be used to select elements of the object. 
\begin{Exercise}
  As a first example, write and use a filter to select only a single
  read from all that align to a particular chromosome and position
  (normally one would also like to include strand as a uniqueness
  criterion; see the \Rfunction{occurrenceFilter} function for a more
  complete implementation).
<<ualignFilter,keep.source=TRUE>>=
ualignFilter <- srFilter(function(x) {
    ## create a numerical index of reads. Divide the index, and
    ## position information between chromosomes. Select the index of a
    ## single read at each unique position. Return the selected index
    ## as a logical vector with the same length as x
    oindex <- seq_len(length(x))
    index <- tapply(oindex, chromosome(x), c)
    pdup <- tapply(position(x), chromosome(x), duplicated)
    keep <- oindex  %in% unlist(mapply(function(i, p) {
        i[!p]
    }, index, pdup))
}, name="select only one read per position")
caln[ualignFilter(caln)]
@ 
\end{Exercise}
The filter functions built-in to \Biocpkg{ShortRead} use a `factory'
pattern to create instances of each filter that `remember' how the
filters were created. For instance, \Rcode{chromosomeFilter("chr2.fa")}
creates an instance of the chromosome filter to select only
chromosomes matching \Rcode{chr2.fa}.
\begin{Exercise}
  As an advanced example, the following filter subsamples a
  (user-specified) number of reads. The \Rfunction{samplingFilter}
  function uses the factory pattern, so filters created with it
  remember how many reads to sample.
<<sampleFunction>>=
samplingFilter <- function(sampleSize) {
    srFilter(function(x) {
        idx <- seq_len(length(x))
        idx %in% sample(idx, sampleSize)
    }, name="Demo sampling filter")
}
sample100 <- samplingFilter(100)
caln[sample100(caln)]
@ 
\end{Exercise}

\subsection{Cautions}

There are several confusing areas associated with reading data aligned
with various software packages. (1) Some alignment programs and genome
resources start numbering nucleotides of the subject sequence at 0,
whereas others start at 1. (2) Some alignment programs report matches
on the minus strand in terms of the `left-most' position of the read
(i.e., the location of the 3' end of the aligned read), whereas other
report `five-prime' matches (i.e., in terms of the 5' end of the
read), regardless of whether the alignment is on the plus or minus
strand. (3) Some alignment programs reverse complement the sequence of
reads aligned to the minus strand. (4) Base qualities are sometimes
encoded as character strings, but the encoding differs between `fastq'
and `solexa fastq'. It seems that all combinations of these choices
are common `in the wild'.

The help page for \Rfunction{readAligned} attempts to be explicit
about how reads are formatted. Briefly:
\begin{itemize}
\item Subject sequence nucleotides are numbered starting at 1, rather
  than zero. \Rfunction{readAligned} adjusts the coordinate system of
  input reads if necessary (e.g., when reading MAQ alignments).
\item ELAND and Bowtie alignments on the minus strand are reported in
  `left-most' coordinates systems.
\item ELAND and Bowtie alignments on the minus strand are not reverse
  complemented.
\item Character-encoded base quality scores are interpreted as the
  default for the software package whose output is being parsed, e.g., as `Solexa
  fastq' for \ELAND{}. The object returned by \Rfunction{quality}
  applied to an \Rclass{AlignedRead} object is either
  \Rclass{FastqQuality} or \Rclass{SFastqQuality}.
\end{itemize}
Alignment programs sometimes offer the opportunity to customize
output; such customization needs to be accommodated when reads are
input using \Biocpkg{ShortRead}.

\section{Additional input functions}

Many sequence alignment programs are producing `bam' (Binary
AlignMent) files. These can be read in to \R{} using
\Rfunction{readAligned} with
\Rfunarg{type="BAM"}. \Rfunction{readAligned} filters reads to include
only those reads alighed without indels; more flexible representation
is available with \Rfunction{readGappedAlignments}, which inputs the
reads and their `cigar' representation. A cigar is a short run length
encoding providing information about how the sequence of nucleotides
in the read align to the reference, including information about
indels. Even greater flexiblity is provided by \Rfunction{scanBam}
function in the \Biocpkg{Rsamtools} package. This will parse \bam{}
files that are either local or remote (e.g., from the 1000 genomes
project), and can be used to efficiently select reads satisfying
particular criteria, e.g., overlapping a particular range or aligned
to the minus strand. See the help page for \Rfunction{scanBam} and
\Rfunction{ScanBamParam} for additional information.

\Biocpkg{ShortRead}, \Biocpkg{Biostrings}, and the standard input
functions from \R{} provide additional tools for reading Illumina and
other alignment formats. The \Rfunction{readXStringColumns} function
provides a convenient way to read DNA and quality sequences into
compact data structures. \Rfunction{readFasta} and its counterpart
\Rfunction{readFastq} provide tools for reading FASTA- or FASTQ-
(i.e., including quality annotation) formatted files.
\begin{Exercise}
  Files \texttt{\_sequence.txt} contain fastq-formatted sequence and
  quality scores. A sample of this file type is available. Read these
  in to data structured defined in \Biocpkg{ShortRead}.  The content
  of \Robject{reads} can be retrieved with the accessor functions \Rfunction{id},
  \Rfunction{sread}, and \Rfunction{quality}.
<<fastq>>=
reads <- readFastq(extdataDir, "s_1_1_sequence_head.txt$")
head(id(reads))
@ 
\end{Exercise}
The \Rfunction{readPrb} functions reads `raw' base call quality scores
from \texttt{\_prb} files in the \Rcode{baseCallPath} directory; the
result is a \Rclass{BStringSet} object that compactly represents the
quality scores in a way analogous to the results of
\Rfunction{quality} applied to \Rcode{aln}.
\begin{Exercise}
  The \texttt{\_export.txt} files read by \Rfunction{readAligned} are
  tab-delimited text files. The goal of this exercise is to read the
  DNA sequence and quality score columns in to \R{} as
  \Rclass{DNAStringSet} and \Rclass{BStringSet} objects.  The
  \Rclass{DNAStringSet} and \Rclass{BStringSet} classes represent DNA
  or `biological' strings; they extend the base class
  \Rclass{XString}.

  Start by parsing the first line of a \texttt{\_prb} file to get a sense
  of its content. Specify the \Rcode{colClasses} to be imported, using
  \Rcode{NULL} to indicate that a column should be skipped, and
  \Rcode{DNAString} or \Rcode{BString} to indicate columns that are to
  be read as the corresponding data types (classes). Read the file with
  \Rfunction{readXStringColumns}.
<<readXStringColumns>>=
fl <- list.files(extdataDir, pattern, full=TRUE)
cols <- strsplit(readLines(fl, 1), "\t")[[1]]
length(cols)
cols[9:10]

colClasses <- rep(list(NULL), 22)
colClasses[9:10] <- c("DNAString", "BString")
strings <- 
    readXStringColumns(extdataDir, pattern, colClasses=colClasses)
head(strings[[2]])
@ 
%% 
  For each column in \Robject{colClasses},
  \Rfunction{readXStringColumns} parses the corresponding column in
  all files matching the function argument \Rfunarg{pattern} into a
  single \Rclass{XStringSet}, i.e., concatenating the content of all
  files into a single object.
\end{Exercise}

\section{Quality assessment} 

This part of the course addresses \Biocpkg{ShortRead} facilities for
assessing quality, primarily of Solexa data. The \Biocpkg{ShortRead}
functionality is mean to complement rather than replace QA tools
provided by the \ELAND{} pipeline.

\subsection{Generating a QA report}.

Creating a QA report is a two-step process. The first step is to visit
necessary files to collate information in a compact
representation. The second step is to present the information in a
useful format.

The \Rfunction{qa} function collates information for the QA report. It
visits each \texttt{\_export.txt} file, and extracts information on reads
and their qualities. Evaluation of the function is straight-forward, e.g.,
\verb|qa <- qa(extdataDir, ".*_export.txt", type="SolexaExport")|. The
process of collating files can be time consuming (each export file
must be parsed, taking 3-4 minutes per file) and memory intensive
(lanes are processed independently of one another, but processing a full lane
consumes 2-3 GB of memory). The return value of the \Rfunction{qa}
function is actually quite compact, and easy to work with.
\begin{Exercise}
  Rather than collating information during the lab, we load the data
  from a previously stored instance.
<<qa-input>>=
data("qa_080828_081110", package="CSAMA10")
qa
@ 
\end{Exercise}
One feature of \Biocpkg{ShortRead} that can speed up this stage of the
operation is the use of clustered computer resources and the
\Rpkg{Rmpi} or \Rpkg{mullticore} package; \Rfunction{qa} uses the
\Rfunction{srapply} function to automatically detect and distribute
collation tasks across pre-established nodes. This is outlined in more
detail in a subsequent section.

The QA information collated from the \texttt{\_export.txt} files is
summarized into an html report using the \Rfunction{report}
function. The command to create the report is
\verb|rpt <- report(qa, dest=tempfile())|.  This creates an HTML file
at the location specified by the argument \Rfunarg{dest}.
\begin{Exercise}
  Create a report from the \Robject{qa} object loaded in the previous
  exercise. Do this with the command
<<qa-report>>=
rpt <- report(qa, dest=tempfile())
@ 
%% 
View the report in your browser with
<<qa-browse, eval=FALSE>>=
browseURL(rpt)    
@ 
\end{Exercise}
The QA report provides summary statistics about the numbers of reads
and alignments, base calls and qualities, characteristics of per-lane
and per-tile read quality, and other information. The QA report is
self-documenting, providing a narrative description of each section.

\subsection{Exploring \Robject{qa}}

The \Robject{qa} object is a list-like structure with several
entities.
\begin{Exercise}
  The \Robject{readCounts} element of \Robject{qa} is a simple data
  frame summarizing, on a per-lane bases, the total number of reads,
  the number of reads passing Solexa internal filtering, and the
  number of aligned reads.
<<qa-readCount>>=
qa[["readCounts"]]
@ 
% 
  Lanes 1-4 and 6-8 correspond to biologically interesting samples;
  lane 5 is the Solexa $\varphi$X-174 control lane. The number of reads
  (between 2.8 and 4.5 million) is low for a typical experiment
  (official guidelines are provided in Solexa documentation).

  It can be difficult to scan large numbers, so the QA report template
  defines functions that help to display the information in a more
  comprehensible fashion. Source these files into your current \R{}
  session, and read the second and third columns as a proportion of
  the first.
<<qa-template-source>>=
ShortRead:::.ppnCount(qa[["readCounts"]])
@ 
% 
  Refer to the QA report for further commentary on this and other
  aspects of the report
\end{Exercise}

\subsection{Frequent sequences}

A feature of raw reads, and of many subsequent stages of short read
analysis, is a power law-like relationship between the number of times
a read occurs, and the number of occurrences of a particular sequence
in the sample. This information is contained in the
\Robject{sequenceDistribution} element of \Robject{qa}, and is the
result of running the \Rfunction{tables} command (defined in
\Biocpkg{ShortRead}) on a \Rclass{DNAStringSet}
object.
\begin{Exercise}
  Retrieve the \Robject{sequenceDistribution} element from
  \Robject{qa}; it is a simple data frame. Look at the contents of the
  data frame using \Rfunction{head}, and select just lane 5 raw reads.
  plot the power-law relationship between the number of reads and
  number of times reads occur. As an
  alternative display of the same information, plot the cumulative
  number of reads as a function of the number of times a read occurs.
<<hoover,fig=TRUE,width=4.5,height=5>>=
df <- qa[["sequenceDistribution"]]
df5raw <- df[df$lane=="s_5_1_export.txt" & df$type=="read",]
head(df5raw)
print(xyplot(log10(nReads)~log10(nOccurrences), df5raw,
             xlab="Copies per read (log 10)",
             ylab="Unique reads (log 10)"))
@ 
<<choover, fig=TRUE,width=4.5,height=5>>=
csum <- with(df5raw, cumsum(nReads * nOccurrences))
csum <- csum / csum[length(csum)]
print(xyplot(csum ~log10(nOccurrences), df5raw,
             xlab="Copies per read (log 10)",
             ylab="Cumulative proportion of reads",
             type="l"))
@
%% 
  Results appear in Figure~\ref{fig:hoover}. The cumulative form of
  this figure appears in the QA report.
\end{Exercise}
\begin{figure}
  \includegraphics[width=.5\textwidth]{Lab-3-ShortRead-hoover}
  \includegraphics[width=.5\textwidth]{Lab-3-ShortRead-choover}
  \caption{Number of copies of unique reads}
  \label{fig:hoover}
\end{figure}

The power-law relationship between copies per read and number of
unique reads in the control lane consists of three components. At the
left of the graph are $>10^5$ reads that are each represented by only
one copy. These likely correspond to sequencing, base calling, or
other errors associated with the technology. At the right of the
figure are a small number of reads represented many times. These
`frequent' sequences are summarized in the \Robject{frequentSequences}
element of \Robject{qa}; frequent sequences are also reported by the
\Rfunction{tables} function of \Biocpkg{ShortRead}.
\begin{Exercise}
  Discover the frequent sequences amongst the raw and aligned reads of
  lane 5.
<<freq-seqs>>=
df <- qa[["frequentSequences"]]
head(df[df$lane=="s_5_1_export.txt" & df$type=="read",1:2])
@ 
\end{Exercise}
Frequent sequences include poly-A reads, reads where only a few bases
were called, and reads with close similarity to the Solexa primer or
adapter sequence used in sample preparation.
\begin{Exercise}
  Many of the primer sequences are filtered out by Solexa criteria,
  but it is worth discovering how many reads are `similar' to this
  sequence. Use the \Rfunction{srdistance} function to identify such
  reads, e.g., amongst those reads that contain no \texttt{N}
  nucleotides.
<<srdistance>>=
seq <- "CGGTTCAGCAGGAATGCCGAGATCGGAAGAGCGGT"
dist <- srdistance(clean(aln), seq)[[1]]
head(table(dist))
@ 
% 
  \Rfunction{srdistance} returns the edit distance between each read
  and the reference sequence, where the edit distance is defined so
  that each base mismatch represents an additional increment of
  1. There are \Sexpr{sum(table(dist)[1:3])} reads that differ at 2 or fewer
  locations, from amongst the \Sexpr{length(clean(aln))} reads in the
  cleaned sample used in this exercise.
\end{Exercise}
Reads represented many times may be problematic for downstream
analysis. For instance, sample preparation protocols may involve a PCR
step that results in differential amplification, whereas the analysis
assumes reads are represented in proportion to their occurrence. The
\Rfunction{ualignFilter} function defined above, and the
\Rfunction{srduplicated} function in \Biocpkg{ShortRead} represent
two approaches to dealing with this problem by ensuring that reads are
represented exactly once (by some definition of `once'!).

Sequences in the middle portion of the graph in
Figure~\ref{fig:hoover} will often, depending on the nature of the
investigation, represent the sequences of main biological
interest. These are sequences represented an intermediate number of
times, as might be required for reasonable coverage in a SNP discovery
or ChIP-seq experiment. The right-hand graph in
Figure~\ref{fig:hoover} shows a relatively abrupt transition between
reads represented rarely and those represented many times. 

The sample QA report shows that the non-control lanes show much
broader transitions from rarely to frequently represented reads. This
could represent technical shortcomings of this run (e.g., inadequate
enrichment of sample DNA) or features of intrinsic biological interest
(e.g., wide variability in ChIP abundance between binding
sites). Regardless of ultimate source, the broad distribution of read
occurrences implies some effort may be required to distinguish `noise'
(reads corresponding to those in the left and right portions of the
control lane graph) from signal.

Finally, while the control lane shows a relatively abrupt transition
between reads that occur rarely and those that are common
(Figure~\ref{fig:hoover}), the distribution is in fact 3- or 4-fold
broader than expected under a naive model of random read starts along
the $\varphi$X-174 genome. This is reinforced by alignments to the
reference genome, where clear patterns (e.g., unequal representation
on plus and minus strands; non-uniform coverage) are apparent.
\begin{Exercise}
  As an advanced exercise, simulate reads selected uniformly along
  both strands of the 5200bp long $\varphi$X-174 genome. Compare the
  times each read is represented in your sample with those from the
  actual control lane. Hint: use \Rfunction{sample} with
  \Rfunarg{replace=TRUE} to generate the reads, and
  \Rcode{table(table(reads))} to summarize their occurrence; this should
  take less than 5 lines of \R{} code.
\end{Exercise}

\subsection{Cycle-specific qualities and base calls}

As a final foray into the details of quality assessment, consider base
calls and quality, and how these change across cycles (see the second
table and Section 4 of the QA report).

The table in the QA report suggests that the control lane (lane 5) is
enriched for A and T; this is confirmed by the figure in section
4. This likely reflects underlying differences in the genomic regions
represented in each lane.
\begin{Exercise}
  Use \Rfunction{alphabetFrequency} to summarize nucleotide use in the
  short reads in \Robject{aln}, from the first part of this lab.
<<alphabetFreqeuncy>>=
alphabetFrequency(sread(aln), collapse=TRUE, baseOnly=TRUE, 
                  as.prob=TRUE)
@
%
  The frequency of `other' (i.e., uncalled) nucleotides ($>9\%$) is
  very high; typical runs are $<1\%$.
\end{Exercise}
An unexpected aspect of the figure in Section 4 of the QA report is
apparent trends in nucleotide frequency with cycle. For instance, all
lanes show a marked decrease in A and increase in C across
cycles. This is unexpected in this experiment, where the \emph{a
  priori} expectation is that sequences start at essentially arbitrary
locations in the sequenced DNA: an A is expected as frequently at the
beginning of the sequence as at the end.
\begin{Exercise}
  Use \Rfunction{alphabetByCycle} to extract the number of each
  nucleotide A, C, T, G, sequenced at each cycle. Plot the transpose
  of the matrix using \Rfunction{matplot}, to see how nucleotide
  counts change across cycles.
<<abc,fig=TRUE,height=5>>=
abc <- alphabetByCycle(sread(aln))
dim(abc)
abc[1:4,1:5]
matplot(t(abc[1:4,]), type="l", xlab="Cycle", ylab="Count")
@ 
\end{Exercise}
\begin{figure}
  \centering
  \includegraphics[width=.95\textwidth]{Lab-3-ShortRead-abc}
  \caption{Nucleotide frequency per cycle, lane 1}
  \label{fig:abc}
\end{figure}
There are a number of possible contributors to cycle-dependent
nucleotide frequencies, including inadequate reagent volume, and
nucleotide-specific differential accumulation of fluorescent
dyes. Figure~\ref{fig:abc} and the figure in Section 4 of the report
contain additional features that are moderately unexpected, and
unexplained. For instance, the frequency of a nucleotide such as A
changes very systematically across cycles, first increasing and then
decreasing; this seems more regular than expected. Patterns of
nucleotide change also seem to echo one another at similar cycles but
in different lanes, even when the lanes have different biological
material. This occurs for instance in lanes 1-4 of the QA report,
where the last 5 cycles of the C nucleotide seem to change in
(comparative!) unison.

\section{Coverage}

Many work flows invovle some aspect of coverage, the depth to which
individual nucleotides in a reference sequence are covered by
nucleotides in reads.
\begin{Exercise}
  Select just those reads that aligned to the reference genome (e.g.,
  using \Rcode{!is.na(position(aln))}). Use the \Rfunction{coverage}
  function to summarize how reads are aligned to chromosomes
<<coverage>>=
cvg <- coverage(aln[!is.na(position(aln))])
@ 
\end{Exercise}

The \Rfunction{coverage} function returns a list-like structure, where
each element of the list represents a chromosome. The data are
represented as a `run length encoded' (\Rclass{Rle})
instance. \Rclass{Rle} instances are readily interogatted for a
variety of useful insights.
\begin{Exercise}
  Select an element of \Robject{cvg} for further investigation. Use
  \Rfunction(slice) to identify all regions where there are at least 2
  reads. Use the \Rfunction{width} accessor and
  \Rfunction{densityplot} function to display the distribution of
  island widths. Use \Rfunction{viewMaxs} and \Rfunction{desnityplot}
  to display the distribution of maximum island depths.
<<slice>>=
slc <- slice(cvg[["chr1.fa"]], 2)
densityplot(log10(width(slc)))
densityplot(viewMaxs(slc))
@ 
\end{Exercise}

There are many additional exploratory opportunities associated with
coverage vectors; we will encounter some of these in ChIP-seq
processing. As a final exercise\ldots
\begin{Exercise}
  The \Biocpkg{rtracklayer} package can export \Robject{Rle} and other
  objects to a format such as gff suitable for viewing in genome
  browsers. Use \Biocpkg{rtracklayer} and its \Rfunction{export}
  function to export a description of the peaks.
<<export>>=
library(rtracklayer)
fl <- tempfile()
export(cvg[["chr1.fa"]], fl, "gff3")
@ 
\end{Exercise}

\section{Summary}

This portion of the course has provided you with an overview of the
input, manipulation, and quality assessment functionality available in
the \Biocpkg{ShortRead} and other packages.  A summary of the insights
learned might be reflected in simple, and somewhat naive, work flows.

The first work flow simply performs quality assessment on \ELAND{}
aligned data.
<<workflow-qa, eval=FALSE>>=
rpt <- report(qa(extdataDir, "_export.txt"),
              dest="reports/my_report.pdf")
@ 
% 
Performing QA on \ELAND{} data does not commit us to using \ELAND{}
alignments in subsequent steps.

The second work flow reads aligned data in to \R{}. The work flow
might start with aligned reads created by one of many aligners; we
start with \ELAND{} \texttt{\_export.txt} files. There are many possible
issues highlighted in the forgoing discussion. We choose to establish
a series of filters to eliminate some reads at the very start of our
work flow. We eliminate reads with ambiguous base calls and failing
Solexa's internal filtering criteria. Reads aligning to multiple
locations in the genome are not straight-forward to deal with, and are
not essential for ChIP-seq style experiments (this is not necessarily
the case for expression or RNA-seq experiments), so we remove
these. Most close matches to the Solexa primer sequence are flagged as
not passing Solexa base call filters, but we eliminate reads near to
this as well. Finally, we restrict our attention to those reads that
align to assembled nuclear chromosomes, putting aside for the moment
those reads aligning to organelle genomes (the X and Y chromosomes
also require special consideration, and we might often eliminate these
from a first-pass work flow, too). Our second work flow is thus:
<<filter,keep.source=TRUE,eval=FALSE>>=
filt1 <- nFilter()
filt2 <- alignDataFilter(expression(filtering=="Y"))
filt3 <- alignQualityFilter(threshold=1)
filt4 <- srdistanceFilter("CGGTTCAGCAGGAATGCCGAGATCGGAAGAGCGGT", 4)
filt5 <- chromosomeFilter("chr[0-9]+.fa")

filt <- compose(filt1, filt2, filt3, filt4, filt5)
aln <- readAligned(extdataDir, pattern, filter=filt)
@ 
% 
This work flow applies equally to MAQ aligned data, with the exception
that Solexa filtering criteria are not available and the chromosome
naming convention in the MAQ-aligned reads in our sample are
different:
<<filter-MAQ,eval=FALSE>>=
maqDir <- "path/to/maq"
filt5 <- chromosomeFilter("chr[0-9XY]+$")
filt <- compose(filt1, filt3, filt4, filt5)
maq <- readAligned(maqDir, "s_8.map", "MAQMap", filter=filt)
@ 
%% 
Each of the filters represents a decision. The decision may be
inappropriate for particular analyses, and may be revisited as
understanding of the data matures. 

The \Rclass{GappedAlignments} class and the \Biocpkg{GenomicRanges}
and \Biocpkg{Rsamtools} packages provide comparable facilities for
input and manipulation of reads aligned with indels.

\section{Session information}

<<sessionInfo,results=tex,echo=FALSE>>=
toLatex(sessionInfo())
@ 

\end{document}

%\VignetteDepends{CSAMA10, ShortRead, GenomicFeatures, rtracklayer}
%\VignetteIndexEntry{Lab 8: RNA-seq Use Case}
%\VignetteKeywords{RNAseq}
%\VignettePackage{CSAMA10}

\documentclass[a4paper]{article}

\usepackage{BioconductorVignette}
\SweaveOpts{keep.source=TRUE, include=FALSE, eps=FALSE}

\title{Lab 8: RNA-seq Use Case}

\author{Patrick Aboyoun \and
        Nicolas Delhomme \and
        Ismael Padioleau}

\date{14-18 June, 2010}

\begin{document}

\bibliographystyle{plain}

<<setup, echo=FALSE>>=
options(width = 60)
olocale=Sys.setlocale(locale="C")
@ 

\maketitle

\tableofcontents

\section{Introduction}

This file describes an RNA-seq analysis use-case.
RNA-seq\cite{Mortazavi:2008p740} was introduced as a new
method to perform Gene Expression Analysis, using the advantages of the
high throughput of Next-Generation Sequencing machines.

The goal of this use-case is to generate a count table for the selected
genetic features of interest, i.e. exons, transcripts, gene models, etc.
In the first part, we will use Bioconductor packages
\Biocpkg{ShortRead}\cite{Morgan:2009p739} and \Biocpkg{GenomicFeatures}
to define the counts for genetic features. This information will then be
exported into a wig formatted file for visualization in the UCSC
genome browser or a stand-alone genome browser like IGB.

\newpage
 
\section{Single sample use case}

In this section, we will demonstrate how to generate a count table containing
the number of sequencing reads that can be assigned to given genetic features.
An expressed genetic feature can be anything from an exon to a gene-model and,
as recently published, enhancers\cite{Kim:2010p572}. In this section, we will
generate such a count table for a single sample.

\subsection{Reading the data}

We read the export file, using the \Biocpkg{ShortRead} package and
have a look at its contents.

<<load-ShortRead>>=
library(ShortRead)
@
<<read-subset-export>>=
aln <-
  readAligned(system.file("extdata", "subset_export.txt.gz",
                          package = "CSAMA10"),
              type = "SolexaExport")
aln
@


\subsection{Filtering the data}

Illumina uses a built-in chastity filter that describes whether a read
cluster could be successfully sequenced, with \texttt{Y} representing
yes and \texttt{N} representing no.

<<chastity-filter>>=
table(chastity = alignData(aln)[["filtering"]],
      aligned = is.na(position(aln)),
      useNA = "ifany")
@

In this sample, roughly 36\% of the reads do not pass the chastity filter
and an additional 7.3\% do not align to the genome. Also, some of these
reads contain many ``N''s, which occurs whenever Bustard, the Illumina base
caller, could not produce a valid base call. All these reads are questionable
and can be filtered out. Filtering for failed chastity calls is not
implemented in the \Biocpkg{ShortRead} package, so we will load the
\Rpackage{CSAMA10} package.

We will use three types of filters on our data:
\begin{enumerate}
  \item Keep reads with at most 2 Ns.
  \item Keep only the alignments to chromosomes chr2L, chr2R, chr3L, chr3R,
    and chr4.
  \item Use Illumina's chastity filter.
\end{enumerate}

<<filter-subset-export>>=
nFilt <- nFilter(2)
chrFilt <- chromosomeFilter(regex = "chr[0-9]")
library(CSAMA10)
cFilt <- CSAMA10::chastityFilter()
filt <- compose(nFilt, chrFilt, cFilt)
aln <- aln[filt(aln)]
aln
@

We are now left with 46,070 ``valid'' alignments, which we want to
assign to their respective exon. For this we need to get the proper
genomic and genetic information.

The \Rclass{AlignedRead} contain is not idea for performing interval
overlap calculations, so we will create a \Rclass{GRanges} instance
that contains the alignment locations. Since this RNA-seq protocol
could not discern strand information, we will set all strand locations
to the wildcard \texttt{*}.

<<alnRanges>>=
alnRanges <- as(aln, "GRanges")
strand(alnRanges) <- "*"
@


\subsection{Obtaining the transcript annotation}

To assign the alignments to their respective exons, we
need to know the genome composition of the model organism
``Drosophila melanogaster''. We can obtain this information using
the \Biocpkg{GenomicFeatures}, which can create annotation databases
using either Biomart or UCSC as a resource. For the purposes of our
analysis, we will use Biomart.

<<load-GenomicFeatures>>=
library(GenomicFeatures)
@

The code to make this from Biomart is

<<make-TxDb-from-Biomart, eval=FALSE>>=
dmTxDb <-
  makeTranscriptDbFromBiomart(biomart = "ensembl",
                              dataset =
                              "dmelanogaster_gene_ensembl")
@

\noindent
but we will load a local copy for expediency.

<<load-TxDb>>=
dmTxDb <-
  loadFeatures(system.file("extdata", "dmTxDb.sqlite",
                           package = "CSAMA10"))
dmTxDb
@

As is typical, the coding for the sequence names differ between
the experiment data and the annotation metadata, so we will
recode the \texttt{seqnames} in the alignments to coincide with
those in the transcript database.

<<renames-seqs>>=
levels(seqnames(alnRanges))
seqnames(dmTxDb)
seqnames(alnRanges) <- sub("^chr", "", seqnames(alnRanges))
seqlengths(alnRanges) <-
  seqlengths(dmTxDb)[names(seqlengths(alnRanges))]
head(alnRanges, 3)
@


\subsection{Analysis of gene models}

Now that we have the alignment locations and the transcript
annotations, we can begin with a coarse model of a gene. For
simplicity we will start with the boundaries for each gene
based upon the transcripts in the \Robject{dmTxDb} object.
The \Rpackage{CSAMA10} package contains the function
\Rfunction{geneBounds} for this purpose. Since we have limited
our examination to chromosomes 2L, 2R, 3L, 3R, and 4 in fly.

<<gene-model-counts>>=
dmGeneBounds <- CSAMA10::geneBounds(dmTxDb)
dmGeneBounds <-
  dmGeneBounds[seqnames(dmGeneBounds) %in%
               levels(seqnames(alnRanges))]
head(dmGeneBounds, 3)
@

In order to determine expression levels for each of these
genes we will count the number of interval overlaps that
occur with the aligned ranges. This can be achieved using the
\Rfunction{countOverlaps} method from the \Biocpkg{GenomicRanges}
package.

<<gene-model-counts, fig=TRUE>>=
dmGeneCounts <- countOverlaps(dmGeneBounds, alnRanges)
names(dmGeneCounts) <- names(dmGeneBounds)
hist(log10(dmGeneCounts+1))
@

\begin{figure}
  \centering
  \includegraphics[width=.8\textwidth]{Lab-8-RNAseqUseCase-gene-model-counts}
  \caption{Distribution of gene model interval overlaps count on the log
    scale.}
  \label{fig:gene-model-counts}
\end{figure}


\subsection{Normalizing counts}

A common way to normalize reads is to convert them to RPKM: reads per
million reads in the library per kb of transcripts. This implies
normalizing the read counts depending on the genic feature size (exon,
transcript, gene model,...) and depending on the total number of reads
sequenced for that library. \Rpackage{CSAMA10} count tables can be
easily transformed into RPKM, by using the \Rfunction{rpkm} method:

<<gene-model-rpkm, fig=TRUE>>=
dmRPKM <- CSAMA10::rpkm(dmGeneCounts, dmGeneBounds)
hist(log10(dmRPKM+1))
@

\begin{figure}
  \centering
  \includegraphics[width=.8\textwidth]{Lab-8-RNAseqUseCase-gene-model-rpkm}
  \caption{Distribution of RPKM on the log scale.}
  \label{fig:gene-model-rpkm}
\end{figure}

\noindent
But such a count normalization is sub-optimal, as you would ``limit''
your dynamic range to the one of the library having the lowest number
of reads. A better way of normalizing the data is to use either
the \Biocpkg{edgeR}\cite{Robinson:2010p775} or
\Biocpkg{DESeq}\cite{Anders:2010p741} packages. The approaches taken
by this packages are explained in their respective vignettes.


\subsection{Differentiating amongst isoforms}

Once we have used other packages such as \Biocpkg{edgeR} and
\Biocpkg{DESeq}, we can use basic Bioconductor tools to find the
interval overlap counts for each of the exons within the known
isoforms of the annotated genes. This counting activity can be
achieved using the \Rfunction{countExonIdsByTxOverlaps} function
within the \Rpackage{CSAMA10} package.

<<isoforms>>=
dmExonIdsByTxCounts <-
  CSAMA10::countExonIdsByTxOverlaps(dmTxDb, alnRanges)
dmExonIdsByTxCounts
@

The output of \Rfunction{countExonIdsByTxOverlaps} is more complex
than the typical R object. It returns a
\Rclass{CompressedSplitDataFrameList} that is split by gene ID,
where each row in the split represent a transcript. These data rows
are comprised of three columns: the transcipt id, the number of
interval overlaps for each exon within the spliced transcript, and
the total number of interval overlaps across the entire spliced
transcript. The elements in this \Rclass{CompressedSplitDataFrameList}
object are sorted in descending order by the transcript with the
largest total interval overlaps.


\subsection{\emph{De novo} transcript identification}

In theory, RNA-seq experiments can be used to identify any transcribed
molecule, since the technique is not dependent on a predefined sets of
probes like micro-arrays are. Therefore, RNA-seq is a potential useful
tool in finding unknown transcripts and isoforms, as well as regulatory
transcribed elements. To that end, several methods are available to
recreate and annotate transcripts, e.g. Oases,
Velvet\cite{Zerbino:2008p749,Zerbino:2009p743},
TopHat\cite{Trapnell:2009p156}, to cite some of them (see
\cite{Ameur:2010p280} as well), but few have been done for other
regulatory transcribed elements such as eRNAs \cite{Kim:2010p572}.
We can use Bioconductor tools to identify locus and quantify counts
without prior annotation knowledge. 

The process begins with calculating the coverage, using the method
from the \Biocpkg{GenomicRanges} package.

<<coverage>>=
cover <- coverage(alnRanges)
head(cover, 2)
@

Next the islands can be formed using the \Rfunction{slice} function.
The peak height for the islands can be found using the
\Rfunction{viewMaxs} function and the island widths can be found using
the \Rfunction{width} function.

<<islands>>=
islands <- slice(cover, 1)
islandPeakHeight <- viewMaxs(islands)
islandWidth <- width(islands)
median(islandPeakHeight)
median(islandWidth)
@

While some sophisticated bioinformatic approaches can be taken to
find exons \emph{de novo} from the RNA-seq sample, we can use a simple
approach whereby we select islands whose maximum peak height is 2 or
more and whose width is 54 bp or more. The \Rfunction{elementLengths}
function calls shows how many of these candidate exons appear on each
chromosome.

<<select-islands>>=
candidateExons <-
  islands[islandPeakHeight >= 1L & islandWidth >= 54L]
elementLengths(candidateExons)
@


\subsection{Exporting the coverage}

If we wish to visualize the coverage of the reads on the genome
in a genome browser, we can use the \Biocpkg{rtracklayer} package
to export the coverage to a wig file.

<<load-rtracklayer>>=
library(rtracklayer)
@

<<export-coverage, eval=FALSE>>=
names(cover) <- paste("chr", names(cover), sep="")
export(cover["chr4"], con = "chr4.wig")
@

You can now visualize it in a genome browser of your choice. This
is a common way to assess if the raw data you are looking at agrees
with the experimental design that was performed. However, this is still
far from being able to normalize and call differential expression between
different conditions, which is usually the goal of RNA-seq
experiments. For more information on the analysis issues, see the
\Biocpkg{DESeq}\cite{Anders:2010p741} Bioconductor package.


\section{De-multiplexing sample use case}

Nowadays, NGS machines produces so many ``raw'' reads (40M for
Illumina, 100M for SOLiD), that the coverage obtained per lane for
the transcriptome of ``small'' genome-sized organisms, is way too
big. Therefore, techniques to have several samples running as part
of the same library have been
created\cite{Lefrancois:2009p778,Smith:2010p777}, using 6bp barcodes
to uniquely identify the sample. This is called multiplexing and one
can today with an average Illumina GenomeAnalyzer GAIIx average run,
multiplex 12 yeast samples and even 2 drosophila samples in a single
lane. Actually, if the lane is very good (30M aligning reads), one can
multiplex 4 of them. This approach is very advantageous for researchers,
especially in term of costs, but it adds an additional layer of
pre-processing that is not as trivial to process as one would have
thought. Extracting the barcodes is fairly straightforward, however
the average 1 percent sequencing error rate introduces a lot of
multiplicity in the actual barcodes present in the samples and this
needs to be sorted out accordingly. A proper design of the barcodes,
maximizing the Hamming distance
(\url{http://en.wikipedia.org/wiki/Hamming\_distance}) is an essential
step for a proper de-multiplexing. 

There are two kinds of barcoding, the one described in Lefrancois
\emph{et al.} \cite{Lefrancois:2009p778} where the barcode is part of
the read sequence and the one developed by Illumina, where the
barcode is read in a separate sequencing reaction after the first
mate sequencing.

<<demultiplexing>>=
alns <-
  readAligned(system.file("extdata", "multiplex_export.txt.gz",
                          package = "CSAMA10"),
              filter =
              compose(chastityFilter(),
                      nFilter(2),
                      chromosomeFilter(regex = "chr[0-9]")),
              type = "SolexaExport",
              withAll = TRUE)
indexes <- c("ACACTG", "ACTAGC", "ATGGCT", "TTGCGA")
demultAlns <-
  demultiplex(alns, indexes=indexes, edit.dist=2, indexes.qty=4,
              type="within")
@


\section{You are done, but still there is more to come...}

It is known that the standard Illumina RNA-seq protocol shows a bias
in the first 12 nucleotides of every read. It is still unclear where
this bias comes from (fragmentation, random hexamer priming, RNase H
sequence specificity), but there has been a couple of publication
recently that proposes corrections for that bias
\cite{Li:2010p732,Hansen:2010p495}. We anticipate creating some
Bioconductor functionality to correct this bias in the near future.


\section{Session Information}

The version number of R\cite{ref:R} and packages loaded for generating
the vignette were:

<<sessionInfo, results=tex, print=TRUE>>=
toLatex(sessionInfo())
@


\bibliography{Lab-8-RNAseqUseCase}


\end{document}
